var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/impl.ts
var impl_exports = {};
__export(impl_exports, {
  Calendar: () => Calendar,
  Duration: () => Duration,
  ExtendedDateTimeFormat: () => ExtendedDateTimeFormat,
  Instant: () => Instant,
  Now: () => Now,
  PlainDate: () => PlainDate,
  PlainDateTime: () => PlainDateTime,
  PlainMonthDay: () => PlainMonthDay,
  PlainTime: () => PlainTime,
  PlainYearMonth: () => PlainYearMonth,
  TimeZone: () => TimeZone,
  ZonedDateTime: () => ZonedDateTime,
  dateToTemporalInstant: () => dateToTemporalInstant
});

// src/argParse/refine.ts
function createOptionParser(propName, map, defaultVal) {
  const valueParser = createParser(propName, map, defaultVal);
  return (options, runtimeDefaultVal) => {
    const ensured = ensureOptionsObj(options);
    return valueParser(ensured[propName], runtimeDefaultVal);
  };
}
function createParser(nameForError, map, defaultVal) {
  return (input, runtimeDefaultVal) => {
    if (input === void 0) {
      const d = runtimeDefaultVal ?? defaultVal;
      if (d === void 0) {
        throw new RangeError(`Must specify a ${nameForError}`);
      }
      return d;
    }
    if (map[input] === void 0) {
      throw new RangeError(`Invalid ${nameForError}: ${input}`);
    }
    return map[input];
  };
}
function constrainInt(val, min, max, overflowHandling) {
  if (val === void 0) {
    return min;
  }
  if (!Number.isFinite(val)) {
    throw new RangeError("Number must be finite");
  }
  val = Math.trunc(val);
  const newVal = Math.min(Math.max(val, min), max);
  if (newVal !== val && overflowHandling === OVERFLOW_REJECT) {
    throw new RangeError("Invalid overflowed value " + val);
  }
  return newVal;
}
function refineFields(input, refinerMap) {
  const res = {};
  let cnt = 0;
  for (const fieldName in refinerMap) {
    if (input[fieldName] !== void 0) {
      res[fieldName] = refinerMap[fieldName](input[fieldName]);
      cnt++;
    }
  }
  if (!cnt) {
    throw new TypeError("Invalid object, no keys");
  }
  return res;
}
function ensureOptionsObj(options) {
  if (options === void 0) {
    return {};
  }
  if (!isObjectLike(options)) {
    throw TypeError("options must be an object or undefined");
  }
  return options;
}
var objectLikeTypeRE = /object|function/;
function isObjectLike(v) {
  return v !== null && objectLikeTypeRE.test(typeof v);
}
var invalidOverrideFields = ["calendar", "timeZone"];
function refineOverrideFields(input, refinerMap) {
  for (const fieldName of invalidOverrideFields) {
    if (input[fieldName] !== void 0) {
      throw new TypeError(`Disallowed field ${fieldName}`);
    }
  }
  return refineFields(input, refinerMap);
}

// src/argParse/overflowHandling.ts
var OVERFLOW_CONSTRAIN = 0;
var OVERFLOW_REJECT = 1;
var overflowHandlingMap = {
  constrain: 0,
  reject: 1
};
var parseOverflowOption = createOptionParser("overflow", overflowHandlingMap, OVERFLOW_CONSTRAIN);

// src/utils/obj.ts
function createWeakMap() {
  const map = /* @__PURE__ */ new WeakMap();
  return [
    map.get.bind(map),
    map.set.bind(map)
  ];
}
function attachGetters(ObjClass, getters) {
  Object.defineProperties(ObjClass.prototype, mapHash(getters, (func) => ({ get: func })));
}
function mapHash(hash, func) {
  const res = {};
  for (const key in hash) {
    res[key] = func(hash[key], key);
  }
  return res;
}
function excludeUndefined(obj) {
  const res = {};
  for (const key in obj) {
    if (obj[key] !== void 0) {
      res[key] = obj[key];
    }
  }
  return res;
}
function strArrayToHash(strs, func) {
  const res = {};
  strs.forEach((str, i) => {
    res[str] = func(str, i);
  });
  return res;
}
function throwNew(ErrorClass, message) {
  throw new ErrorClass(message);
}

// src/dateUtils/abstract.ts
var formatFactoryFactorySymbol = Symbol();
function ensureObj(ObjClass, arg, ...otherArgs) {
  if (arg instanceof ObjClass) {
    return arg;
  }
  return ObjClass.from(arg, ...otherArgs);
}
var AbstractObj = class {
  toJSON() {
    return this.toString();
  }
};
var AbstractNoValueObj = class extends AbstractObj {
  valueOf() {
    throw new Error("Cannot convert object using valueOf");
  }
};
var [getISOFields, setISOFields] = createWeakMap();
var AbstractISOObj = class extends AbstractNoValueObj {
  constructor(isoFields) {
    super();
    setISOFields(this, Object.freeze(isoFields));
  }
  getISOFields() {
    return getISOFields(this);
  }
};

// src/dateUtils/units.ts
var NANOSECOND = 0;
var MICROSECOND = 1;
var MILLISECOND = 2;
var SECOND = 3;
var MINUTE = 4;
var HOUR = 5;
var DAY = 6;
var WEEK = 7;
var MONTH = 8;
var YEAR = 9;
var nanoInMicroBI = 1000n;
var nanoInMilliBI = 1000000n;
var nanoInSecondBI = 1000000000n;
var nanoInMinuteBI = 60000000000n;
var nanoInHourBI = 3600000000000n;
var nanoInDayBI = 86400000000000n;
var nanoInMicro = 1e3;
var nanoInMilli = 1e6;
var nanoInSecond = 1e9;
var nanoInMinute = 6e10;
var nanoInHour = 36e11;
var nanoInDay = 864e11;
var nanoIn = [
  1,
  nanoInMicro,
  nanoInMilli,
  nanoInSecond,
  nanoInMinute,
  nanoInHour,
  nanoInDay
];
var milliInDay = 864e5;
var milliInSecond = 1e3;
var secondsInDay = 24 * 60 * 60;
var unitDigitMap = [
  9,
  6,
  3
];
function isDayTimeUnit(unit) {
  return unit <= DAY;
}
function isDateUnit(unit) {
  return unit >= DAY;
}

// src/argParse/roundingMode.ts
var roundingModeMap = {
  halfExpand: Math.round,
  ceil: Math.ceil,
  trunc: Math.trunc,
  floor: Math.floor
};
var parseRoundingModeOption = createOptionParser("roundingMode", roundingModeMap);

// src/argParse/unitStr.ts
var timeUnitNames = [
  "nanosecond",
  "microsecond",
  "millisecond",
  "second",
  "minute",
  "hour"
];
var dateUnitNames = [
  "day",
  "week",
  "month",
  "year"
];
var unitNames = [
  ...timeUnitNames,
  ...dateUnitNames
];
var durationUnitNames = unitNames.map((unit) => unit + "s");
var unitMap = strArrayToHash(unitNames, (_str, i) => i);
var pluralUnitMap = strArrayToHash(durationUnitNames, (_str, i) => i);
function parseUnit(input, defaultUnit, minUnit, maxUnit) {
  let num;
  if (input === void 0) {
    if (defaultUnit === void 0) {
      throw new RangeError("Unit is required");
    }
    num = defaultUnit;
  } else {
    num = unitMap[input] ?? pluralUnitMap[input];
    if (num === void 0 || num < minUnit || num > maxUnit) {
      throw new RangeError("Invalid unit " + input);
    }
  }
  return num;
}

// src/argParse/roundingOptions.ts
function parseRoundingOptions(options, smallestUnitDefault, minUnit, maxUnit, forDiffing, forInstant) {
  if (smallestUnitDefault === void 0 && !isObjectLike(options)) {
    throw new TypeError("Need rounding options");
  }
  const ensuredOptions = ensureOptionsObj(options);
  const roundingIncrement = ensuredOptions.roundingIncrement ?? 1;
  const smallestUnit = parseUnit(ensuredOptions.smallestUnit, smallestUnitDefault, minUnit, maxUnit);
  if (!forDiffing && forInstant) {
    if (smallestUnit < DAY && nanoInDay % roundingIncrement * nanoIn[smallestUnit]) {
      throw new RangeError("Increment must evenly divide into 24 hours");
    }
  } else {
    if (smallestUnit < DAY ? nanoIn[smallestUnit + 1] % roundingIncrement : !forDiffing && roundingIncrement !== 1) {
      throw new RangeError("roundingIncrement does not divide evenly into next highest unit");
    }
    if (smallestUnit < DAY && roundingIncrement * nanoIn[smallestUnit] >= nanoIn[smallestUnit + 1]) {
      throw new RangeError("roundingIncrement must be less than next highest unit");
    }
  }
  return {
    smallestUnit,
    roundingMode: parseRoundingModeOption(options, forDiffing ? Math.trunc : Math.round),
    roundingIncrement
  };
}

// src/argParse/diffOptions.ts
function parseDiffOptions(options, largestUnitDefault, smallestUnitDefault, minUnit, maxUnit, forInstant, forRounding) {
  const roundingConfig = parseRoundingOptions(options, smallestUnitDefault, minUnit, maxUnit, !forRounding, forInstant);
  largestUnitDefault = Math.max(largestUnitDefault, roundingConfig.smallestUnit);
  let largestUnitArg = ensureOptionsObj(options).largestUnit;
  if (largestUnitArg === "auto") {
    largestUnitArg = void 0;
  }
  const largestUnit = parseUnit(largestUnitArg, largestUnitDefault, minUnit, maxUnit);
  if (roundingConfig.smallestUnit > largestUnit) {
    throw new RangeError("Bad smallestUnit/largestUnit");
  }
  return {
    largestUnit,
    ...roundingConfig
  };
}

// src/utils/math.ts
function compareValues(a, b) {
  if (a < b) {
    return -1;
  } else if (a > b) {
    return 1;
  }
  return 0;
}
function numSign(num) {
  return compareValues(num, 0);
}
function roundToIncrement(num, inc, roundingFunc) {
  return roundingFunc(num / inc) * inc;
}
function roundToIncrementBI(num, inc, roundingFunc) {
  const incBI = BigInt(inc);
  const wholeUnits = num / incBI;
  const wholeNum = wholeUnits * incBI;
  const leftover = Number(num - wholeNum);
  return wholeNum + BigInt(roundingFunc(leftover / inc)) * incBI;
}
function positiveModulo(n, max) {
  return (n % max + max) % max;
}

// src/dateUtils/isoMath.ts
var isoEpochOriginYear = 1970;
var isoEpochLeapYear = 1972;
function isoFieldsToEpochNano(isoFields) {
  return isoToEpochNano(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond);
}
function isoFieldsToEpochSecs(isoFields) {
  return Math.floor(isoFieldsToEpochMilli(isoFields) / milliInSecond);
}
function isoFieldsToEpochMilli(isoFields) {
  return isoToEpochMilli(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond);
}
function isoToEpochNano(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond, isoMicrosecond, isoNanosecond) {
  return BigInt(isoToEpochMilli(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond)) * nanoInMilliBI + BigInt(isoMicrosecond ?? 0) * nanoInMicroBI + BigInt(isoNanosecond ?? 0);
}
function isoToEpochMilli(isoYear, isoMonth, isoDay, isoHour, isoMinute, isoSecond, isoMillisecond) {
  const isoYearReal = isoYear ?? isoEpochOriginYear;
  const isoMonthReal = isoMonth ?? 1;
  const isoDayReal = isoDay ?? 1;
  const sign = numSign(isoYearReal);
  let dayShiftAbs = 0;
  let isoDayTry;
  let milli;
  const twoDigitYearBug = isoYearReal >= 0 && isoYearReal < 1e3;
  const isoYearTemp = twoDigitYearBug ? isoYearReal + 1200 : isoYearReal;
  for (; dayShiftAbs < 31; dayShiftAbs++) {
    isoDayTry = isoDayReal - sign * dayShiftAbs;
    const milliTry = Date.UTC(isoYearTemp, isoMonthReal - 1, isoDayTry, isoHour ?? 0, isoMinute ?? 0, isoSecond ?? 0, isoMillisecond ?? 0);
    if (!isInvalid(milliTry)) {
      milli = milliTry + sign * dayShiftAbs * milliInDay;
      break;
    }
  }
  if (milli === void 0 || isoDayTry < 1 || isoDayTry > isoCalendarImpl.daysInMonth(isoYearReal, isoMonthReal)) {
    throwOutOfRange();
  }
  if (twoDigitYearBug) {
    milli = new Date(milli).setUTCFullYear(isoYearReal);
  }
  return milli;
}
function epochNanoToISOFields(epochNano) {
  let epochMilli = epochNano / nanoInMilliBI;
  let leftoverNano = Number(epochNano - epochMilli * nanoInMilliBI);
  if (leftoverNano < 0) {
    leftoverNano += nanoInMilli;
    epochMilli -= 1n;
  }
  const isoMicrosecond = Math.floor(leftoverNano / nanoInMicro);
  leftoverNano -= isoMicrosecond * nanoInMicro;
  return {
    ...epochMilliToISOFields(Number(epochMilli)),
    isoMicrosecond,
    isoNanosecond: leftoverNano
  };
}
function epochMilliToISOFields(epochMilli) {
  const [legacy, dayUnshift] = nudgeToLegacyDate(epochMilli);
  return {
    isoYear: legacy.getUTCFullYear(),
    isoMonth: legacy.getUTCMonth() + 1,
    isoDay: legacy.getUTCDate() + dayUnshift,
    isoHour: legacy.getUTCHours(),
    isoMinute: legacy.getUTCMinutes(),
    isoSecond: legacy.getUTCSeconds(),
    isoMillisecond: legacy.getUTCMilliseconds()
  };
}
function epochSecondsToISOYear(epochSeconds) {
  return nudgeToLegacyDate(epochSeconds * milliInSecond)[0].getUTCFullYear();
}
function isoYearToEpochSeconds(isoYear) {
  return Math.floor(isoToEpochMilli(isoYear) / milliInSecond);
}
function diffDaysMilli(milli0, milli1) {
  return Math.round((milli1 - milli0) / milliInDay);
}
function addDaysMilli(milli, days) {
  return milli + days * milliInDay;
}
function computeISODayOfWeek(isoYear, isoMonth, isoDay) {
  const [legacy, dayUnshift] = nudgeToLegacyDate(isoToEpochMilli(isoYear, isoMonth, isoDay));
  return positiveModulo(legacy.getUTCDay() + dayUnshift, 7) || 7;
}
function nudgeToLegacyDate(epochMilli) {
  const sign = numSign(epochMilli);
  let dayShiftAbs = 0;
  let date;
  for (; dayShiftAbs < 31; dayShiftAbs++) {
    const dateTry = new Date(epochMilli - sign * dayShiftAbs * milliInDay);
    if (!isInvalid(dateTry)) {
      date = dateTry;
      break;
    }
  }
  if (date === void 0) {
    throwOutOfRange();
  }
  return [date, sign * dayShiftAbs];
}
function isInvalid(n) {
  return isNaN(n.valueOf());
}
function throwOutOfRange() {
  throw new RangeError("Date outside of supported range");
}

// src/utils/string.ts
function capitalizeFirstLetter(s) {
  return s.charAt(0).toUpperCase() + s.slice(1);
}
function padZeros(num, length) {
  return String(num).padStart(length, "0");
}
function getSignStr(num) {
  return num < 0 ? "-" : "+";
}

// src/calendarImpl/eraOrigins.ts
var eraOrigins = {
  gregory: {
    bce: -1,
    ce: 0
  },
  ethioaa: {
    era0: 0
  },
  ethiopic: {
    era0: 0,
    era1: 5500
  },
  coptic: {
    era0: -1,
    era1: 0
  },
  roc: {
    beforeroc: -1,
    minguo: 0
  },
  buddhist: {
    be: 0
  },
  islamic: {
    ah: 0
  },
  indian: {
    saka: 0
  },
  persian: {
    ap: 0
  },
  japanese: {
    bce: -1,
    ce: 0,
    meiji: 1867,
    taisho: 1911,
    showa: 1925,
    heisei: 1988,
    reiwa: 2018
  }
};

// src/calendarImpl/calendarImpl.ts
var CalendarImpl = class {
  constructor(id) {
    this.id = id;
  }
  monthCode(month, _year) {
    return "M" + padZeros(month, 2);
  }
  convertMonthCode(monthCode, _year) {
    const monthCodeIsLeap = /L$/.test(monthCode);
    const monthCodeInt = parseInt(monthCode.substr(1));
    if (monthCodeIsLeap) {
      throw new RangeError("Calendar system doesnt support leap months");
    }
    return [monthCodeInt, false];
  }
};
function convertEraYear(calendarID, eraYear, era, fromDateTimeFormat) {
  let origin = eraOrigins[getCalendarIDBase(calendarID)]?.[era];
  if (origin === void 0) {
    if (fromDateTimeFormat) {
      origin = 0;
    } else {
      throw new Error("Unkown era " + era);
    }
  }
  return (origin + eraYear) * (numSign(origin) || 1);
}
function hasEras(calendarID) {
  return eraOrigins[getCalendarIDBase(calendarID)] !== void 0;
}
function getCalendarIDBase(calendarID) {
  return calendarID.split("-")[0];
}

// src/calendarImpl/isoCalendarImpl.ts
var ISOCalendarImpl = class extends CalendarImpl {
  computeFields(epochMilli) {
    const fields = epochMilliToISOFields(epochMilli);
    return {
      era: void 0,
      eraYear: void 0,
      year: fields.isoYear,
      month: fields.isoMonth,
      day: fields.isoDay
    };
  }
  epochMilliseconds(year, month, day) {
    return isoToEpochMilli(year, month, day);
  }
  daysInMonth(year, month) {
    if (month === 2) {
      return this.inLeapYear(year) ? 29 : 28;
    }
    if (month === 4 || month === 6 || month === 9 || month === 11) {
      return 30;
    }
    return 31;
  }
  monthsInYear() {
    return 12;
  }
  inLeapYear(year) {
    return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
  }
  guessYearForMonthDay() {
    return isoEpochLeapYear;
  }
  normalizeISOYearForMonthDay() {
    return isoEpochLeapYear;
  }
};
var isoCalendarID = "iso8601";
var isoCalendarImpl = new ISOCalendarImpl(isoCalendarID);

// src/calendarImpl/gregoryCalendarImpl.ts
var GregoryCalendarImpl = class extends ISOCalendarImpl {
  computeFields(epochMilli) {
    const fields = super.computeFields(epochMilli);
    const { year } = fields;
    return {
      ...fields,
      era: year < 1 ? "bce" : "ce",
      eraYear: year < 1 ? -(year - 1) : year
    };
  }
};

// src/argParse/calendarDisplay.ts
var CALENDAR_DISPLAY_AUTO = 0;
var CALENDAR_DISPLAY_NEVER = 1;
var CALENDAR_DISPLAY_ALWAYS = 2;
var calendarDisplayMap = {
  auto: 0,
  never: 1,
  always: 2
};
var parseCalendarDisplayOption = createOptionParser("calendarName", calendarDisplayMap, CALENDAR_DISPLAY_AUTO);

// src/argParse/fieldStr.ts
var yearMonthFieldMap = {
  era: String,
  eraYear: Number,
  year: Number,
  month: Number,
  monthCode: String
};
var dateFieldMap = {
  ...yearMonthFieldMap,
  day: Number
};
var timeFieldMap = {
  hour: Number,
  minute: Number,
  second: Number,
  millisecond: Number,
  microsecond: Number,
  nanosecond: Number
};
var dateTimeFieldMap = {
  ...dateFieldMap,
  ...timeFieldMap
};
var zonedDateTimeFieldMap = {
  ...dateTimeFieldMap,
  offset: String
};
var durationFieldMap = strArrayToHash(durationUnitNames, () => Number);

// src/argParse/offsetHandling.ts
var OFFSET_PREFER = 0;
var OFFSET_USE = 1;
var OFFSET_IGNORE = 2;
var OFFSET_REJECT = 3;
var offsetHandlingMap = {
  prefer: 0,
  use: 1,
  ignore: 2,
  reject: 3
};
var parseOffsetHandlingOption = createOptionParser("offset", offsetHandlingMap);

// src/argParse/isoFormatOptions.ts
function parseTimeToStringOptions(options, largestUnit = MINUTE) {
  const ensuredOptions = ensureOptionsObj(options);
  const smallestUnitArg = ensuredOptions.smallestUnit;
  const digitsArg = ensuredOptions.fractionalSecondDigits;
  let smallestUnit = NANOSECOND;
  let roundingIncrement = 1;
  let digits;
  if (smallestUnitArg !== void 0) {
    smallestUnit = parseUnit(smallestUnitArg, void 0, NANOSECOND, largestUnit);
    roundingIncrement = nanoIn[smallestUnit];
    digits = unitDigitMap[smallestUnit] || 0;
  } else if (digitsArg !== void 0 && digitsArg !== "auto") {
    digits = constrainInt(digitsArg, 0, 9, OVERFLOW_REJECT);
    roundingIncrement = Math.pow(10, 9 - digits);
  }
  return {
    smallestUnit,
    fractionalSecondDigits: digits,
    roundingMode: parseRoundingModeOption(options, Math.trunc),
    roundingIncrement
  };
}

// src/argParse/timeZoneDisplay.ts
var TIME_ZONE_DISPLAY_AUTO = 0;
var TIME_ZONE_DISPLAY_NEVER = 1;
var timeZoneDisplayMap = {
  auto: 0,
  never: 1
};
var parseTimeZoneDisplayOption = createOptionParser("timeZoneName", timeZoneDisplayMap, TIME_ZONE_DISPLAY_AUTO);

// src/dateUtils/mixins.ts
function mixinEpochFields(ObjClass) {
  attachGetters(ObjClass, {
    epochMicroseconds() {
      return this.epochNanoseconds / nanoInMicroBI;
    },
    epochMilliseconds() {
      return Number(this.epochNanoseconds / nanoInMilliBI);
    },
    epochSeconds() {
      return Number(this.epochNanoseconds / nanoInSecondBI);
    }
  });
}
var isoFieldMap = {
  calendar: "calendar"
};
for (const unitName of unitNames) {
  isoFieldMap[unitName] = "iso" + capitalizeFirstLetter(unitName);
}
function mixinISOFields(ObjClass, unitNames2 = []) {
  attachGetters(ObjClass, strArrayToHash(unitNames2.concat("calendar"), (propName) => function() {
    return this.getISOFields()[isoFieldMap[propName]];
  }));
}
var yearMonthCalendarFields = [
  "era",
  "eraYear",
  "year",
  "month",
  "monthCode",
  "daysInMonth",
  "daysInYear",
  "monthsInYear",
  "inLeapYear"
];
var monthDayCalendarFields = [
  "monthCode",
  "day"
];
var dateCalendarFields = [
  ...yearMonthCalendarFields,
  "day",
  "dayOfWeek",
  "dayOfYear",
  "weekOfYear",
  "daysInWeek"
];
function mixinCalendarFields(ObjClass, propNames) {
  attachGetters(ObjClass, strArrayToHash(propNames, (propName) => function() {
    const value = this.calendar[propName](this);
    Object.defineProperty(this, propName, { value });
    return value;
  }));
}

// src/dateUtils/parseRegExp.ts
var yearMonthRegExpStr = "([+-]\\d{6}|\\d{4})-?(\\d{2})";
var dateRegExpStr = yearMonthRegExpStr + "-?(\\d{2})";
var monthDayRegExpStr = "(--)?(\\d{2})-?(\\d{2})";
var timeRegExpStr = "(\\d{2})(:?(\\d{2})(:?(\\d{2})([.,](\\d{1,9}))?)?)?";
var dateTimeRegExpStr = dateRegExpStr + "([T ]" + timeRegExpStr + ")?";
var offsetRegExpStr = "([+-])" + timeRegExpStr;
var endingRegExpStr = "(Z|" + offsetRegExpStr + ")?(\\[([^=\\]]+)\\])?(\\[u-ca=([^\\]]+)\\])?";
var yearMonthRegExp = createRegExp(yearMonthRegExpStr + endingRegExpStr);
var monthDayRegExp = createRegExp(monthDayRegExpStr + endingRegExpStr);
var dateTimeRegExp = createRegExp(dateTimeRegExpStr + endingRegExpStr);
var timeRegExp = createRegExp(timeRegExpStr + endingRegExpStr);
var offsetRegExp = createRegExp(offsetRegExpStr);
var durationRegExp = /^([-+])?P(\d+Y)?(\d+M)?(\d+W)?(\d+D)?(T((\d+)([.,](\d{1,9}))?H)?((\d+)([.,](\d{1,9}))?M)?((\d+)([.,](\d{1,9}))?S)?)?$/i;
var unicodeDashRegExp = /\u2212/g;
function createRegExp(meat) {
  return new RegExp(`^${meat}$`, "i");
}

// src/dateUtils/parse.ts
function parseZonedDateTime(str) {
  const res = tryParseZonedDateTime(str);
  if (!res) {
    throw createParseError("dateTime", str);
  }
  return res;
}
function parseDateTime(str) {
  const res = tryParseDateTime(str);
  if (!res) {
    throw createParseError("dateTime", str);
  }
  return res;
}
function parseYearMonth(str) {
  const res = tryParseYearMonth(str) || tryParseDateTime(str);
  if (!res) {
    throw createParseError("yearMonth", str);
  }
  return res;
}
function parseMonthDay(str) {
  const res = tryParseMonthDay(str) || tryParseDateTime(str);
  if (!res) {
    throw createParseError("monthDay", str);
  }
  return res;
}
function parseOffsetNano(str) {
  const res = tryParseOffsetNano(str);
  if (res === void 0) {
    throw createParseError("timeZone", str);
  }
  return res;
}
function parseTime(str) {
  const res = tryParseTime(str) || tryParseDateTime(str);
  if (res === void 0) {
    throw createParseError("time", str);
  }
  return res;
}
function tryParseZonedDateTime(str) {
  const m = dateTimeRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseZonedDateTimeParts(m.slice(1));
  }
}
function tryParseDateTime(str) {
  const m = dateTimeRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseDateTimeParts(m.slice(1));
  }
}
function tryParseYearMonth(str) {
  const m = yearMonthRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseYearMonthParts(m.slice(1));
  }
}
function tryParseMonthDay(str) {
  const m = monthDayRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseMonthDayParts(m.slice(1));
  }
}
function tryParseTime(str) {
  const m = timeRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseTimeParts(m.slice(1));
  }
}
function tryParseOffsetNano(str) {
  const m = offsetRegExp.exec(normalizeDashes(str));
  if (m) {
    return parseOffsetParts(m.slice(1));
  }
}
function parseZonedDateTimeParts(parts) {
  const zOrOffset = parts[11];
  let offset;
  let Z = false;
  if (zOrOffset) {
    Z = zOrOffset.toUpperCase() === "Z";
    offset = Z ? 0 : parseOffsetParts(parts.slice(12));
  }
  return {
    ...parseDateTimeParts(parts),
    timeZone: parts[21],
    offset,
    Z
  };
}
function parseDateTimeParts(parts) {
  return {
    calendar: parts[23],
    isoYear: toInt1(parts[0]),
    isoMonth: toInt1(parts[1]),
    isoDay: toInt1(parts[2]),
    ...parseTimeParts(parts.slice(4))
  };
}
function parseYearMonthParts(parts) {
  return {
    calendar: parts[14],
    isoYear: toInt1(parts[0]),
    isoMonth: toInt1(parts[1]),
    isoDay: 1
  };
}
function parseMonthDayParts(parts) {
  return {
    calendar: parts[15],
    isoYear: isoEpochLeapYear,
    isoMonth: toInt1(parts[1]),
    isoDay: toInt1(parts[2])
  };
}
function parseTimeParts(parts) {
  const isoSecond = toInt0(parts[4]);
  return {
    ...timeLikeToISO(nanoToDayTimeFields(BigInt(parseNanoAfterDecimal(parts[6] || "")), MILLISECOND)),
    isoHour: toInt0(parts[0]),
    isoMinute: toInt0(parts[2]),
    isoSecond: isoSecond === 60 ? 59 : isoSecond
  };
}
function parseOffsetParts(parts) {
  return (parts[0] === "+" ? 1 : -1) * timePartsToNano(parts.slice(1));
}
function timePartsToNano(parts) {
  return toInt0(parts[0]) * nanoInHour + toInt0(parts[2]) * nanoInMinute + toInt0(parts[4]) * nanoInSecond + parseNanoAfterDecimal(parts[6] || "");
}
function parseNanoAfterDecimal(str) {
  return parseInt(str.padEnd(9, "0"));
}
function toInt0(input) {
  return parseInt(input || "0");
}
function toInt1(input) {
  return parseInt(input || "1");
}
function toIntMaybe(input) {
  return input === void 0 ? void 0 : parseInt(input);
}
function normalizeDashes(str) {
  return str.replace(unicodeDashRegExp, "-");
}
function createParseError(type, str) {
  throw new RangeError(`Cannot parse ${type} '${str}'`);
}

// src/dateUtils/totalUnits.ts
function computeTotalUnits(duration, unit, relativeToArg) {
  const fields = durationToDayTimeFields(duration);
  if (relativeToArg === void 0 && fields && isDayTimeUnit(unit)) {
    return Number(dayTimeFieldsToNano(fields)) / nanoIn[unit];
  }
  const relativeTo = extractRelativeTo(relativeToArg);
  const balancedDuration = balanceComplexDuration(duration, unit, relativeTo, true);
  const durationLike = computeExactDuration(balancedDuration, unit, relativeTo, relativeTo.add(balancedDuration));
  return durationLike[durationUnitNames[unit]];
}
function computeExactDuration(balancedDuration, smallestUnit, d0, d1) {
  const smallestUnitName = durationUnitNames[smallestUnit];
  const { sign } = balancedDuration;
  const dur = {};
  for (let unit = YEAR; unit >= smallestUnit; unit--) {
    const durationUnit = durationUnitNames[unit];
    dur[durationUnit] = balancedDuration[durationUnit];
  }
  const incDur = { [smallestUnitName]: sign };
  const startDateTime = d0.add(dur);
  const endDateTime = startDateTime.add(incDur);
  const startNano = realisticEpochNano(startDateTime);
  const endNano = realisticEpochNano(endDateTime);
  const middleNano = realisticEpochNano(d1);
  const unitFrac = Number(middleNano - startNano) / Number(endNano - startNano) * sign;
  dur[smallestUnitName] += unitFrac;
  return dur;
}
function realisticEpochNano(dt) {
  const { epochNanoseconds } = dt;
  return epochNanoseconds !== void 0 ? epochNanoseconds : isoFieldsToEpochNano(dt.getISOFields());
}

// src/argParse/disambig.ts
var DISAMBIG_COMPATIBLE = 0;
var DISAMBIG_EARLIER = 1;
var DISAMBIG_REJECT = 3;
var disambigMap = {
  compatible: 0,
  earlier: 1,
  later: 2,
  reject: 3
};
var parseDisambigOption = createOptionParser("disambiguation", disambigMap, DISAMBIG_COMPATIBLE);

// src/argParse/offsetDisplay.ts
var OFFSET_DISPLAY_AUTO = 0;
var offsetDisplayMap = {
  auto: 0,
  never: 1
};
var parseOffsetDisplayOption = createOptionParser("offset", offsetDisplayMap, OFFSET_DISPLAY_AUTO);

// src/dateUtils/parseRefine.ts
function refineBaseObj(parsed) {
  return {
    ...parsed,
    calendar: parsed.calendar === void 0 ? createDefaultCalendar() : new Calendar(parsed.calendar)
  };
}
function refineZonedObj(parsed) {
  return {
    ...refineBaseObj(parsed),
    timeZone: new TimeZone(parsed.timeZone)
  };
}

// src/timeZoneImpl/timeZoneImpl.ts
var TimeZoneImpl = class {
  constructor(id) {
    this.id = id;
  }
};

// src/timeZoneImpl/fixedTimeZoneImpl.ts
var FixedTimeZoneImpl = class extends TimeZoneImpl {
  constructor(id, offsetSecs) {
    super(id);
    this.offsetSecs = offsetSecs;
  }
  getPossibleOffsets() {
    return [this.offsetSecs];
  }
  getOffset() {
    return this.offsetSecs;
  }
  getTransition() {
    return void 0;
  }
};

// src/dateUtils/intlFormat.ts
function hashIntlFormatParts(format, epochMillisecond) {
  const hash = {};
  const parts = format.formatToParts(epochMillisecond);
  for (const part of parts) {
    hash[part.type] = part.value;
  }
  return hash;
}
var eraRemap = {
  bc: "bce",
  ad: "ce"
};
function normalizeShortEra(formattedEra) {
  formattedEra = formattedEra.toLowerCase().normalize("NFD").replace(/[^a-z0-9]/g, "");
  return eraRemap[formattedEra] || formattedEra;
}

// src/native/intlUtils.ts
var OrigDateTimeFormat = Intl.DateTimeFormat;
function normalizeAndCopyLocalesArg(localesArg) {
  return [].concat(localesArg || []);
}
function flattenOptions(options) {
  const newOptions = {};
  for (const name in options) {
    let val = options[name];
    if (isObjectLike(val)) {
      val = val.toString();
    }
    newOptions[name] = val;
  }
  return newOptions;
}

// src/timeZoneImpl/specialCases.ts
var specialCases = {
  "Pacific/Apia": {
    2011: [
      [1301752800, -36e3, -39600],
      [1316872800, -39600, -36e3],
      [1325239200, -36e3, 50400]
    ]
  }
};

// src/timeZoneImpl/intlTimeZoneImpl.ts
var MAX_YEAR_TRAVEL = 100;
var ISLAND_SEARCH_DAYS = [
  182,
  91,
  273
];
var IntlTimeZoneImpl = class extends TimeZoneImpl {
  constructor(id) {
    const format = new OrigDateTimeFormat("en-GB", {
      era: "short",
      year: "numeric",
      month: "numeric",
      day: "numeric",
      hour: "numeric",
      minute: "numeric",
      second: "numeric",
      timeZone: id
    });
    super(format.resolvedOptions().timeZone);
    this.format = format;
    this.yearEndOffsets = {};
    this.transitionsInYear = specialCases[id] || {};
  }
  getPossibleOffsets(zoneSecs) {
    const transitions = [
      this.getTransition(zoneSecs, -1),
      this.getTransition(zoneSecs - 1, 1)
    ].filter(Boolean);
    let lastOffsetSecs;
    for (const transition of transitions) {
      const [transitionEpochSecs, offsetSecsBefore, offsetSecsAfter] = transition;
      const epochSecsA = zoneSecs - offsetSecsBefore;
      const epochSecsB = zoneSecs - offsetSecsAfter;
      if (transitionEpochSecs > epochSecsA && transitionEpochSecs > epochSecsB) {
        return [offsetSecsBefore];
      } else if (transitionEpochSecs <= epochSecsA && transitionEpochSecs <= epochSecsB) {
      } else {
        return [offsetSecsBefore, offsetSecsAfter];
      }
      lastOffsetSecs = offsetSecsAfter;
    }
    if (lastOffsetSecs !== void 0) {
      return [lastOffsetSecs];
    }
    return [this.getYearEndOffset(epochSecondsToISOYear(zoneSecs))];
  }
  getOffset(epochSecs) {
    const map = hashIntlFormatParts(this.format, epochSecs * milliInSecond);
    let year = parseInt(map.year);
    if (normalizeShortEra(map.era) === "bce") {
      year = -(year - 1);
    }
    const zoneMilli = isoToEpochMilli(year, parseInt(map.month), parseInt(map.day), parseInt(map.hour), parseInt(map.minute), parseInt(map.second));
    const zoneSecs = Math.floor(zoneMilli / milliInSecond);
    return zoneSecs - epochSecs;
  }
  getTransition(epochSecs, direction) {
    const startYear = epochSecondsToISOYear(epochSecs);
    for (let yearTravel = 0; yearTravel < MAX_YEAR_TRAVEL; yearTravel++) {
      const year = startYear + yearTravel * direction;
      const transitions = this.getTransitionsInYear(year);
      const len = transitions.length;
      const startIndex = direction < 0 ? len - 1 : 0;
      for (let travel = 0; travel < len; travel++) {
        const transition = transitions[startIndex + travel * direction];
        if (compareValues(transition[0], epochSecs) === direction) {
          return transition;
        }
      }
    }
  }
  getYearEndOffset(utcYear) {
    const { yearEndOffsets } = this;
    return yearEndOffsets[utcYear] || (yearEndOffsets[utcYear] = this.getOffset(isoYearToEpochSeconds(utcYear + 1) - 1));
  }
  getTransitionsInYear(utcYear) {
    const { transitionsInYear } = this;
    return transitionsInYear[utcYear] || (transitionsInYear[utcYear] = this.computeTransitionsInYear(utcYear));
  }
  computeTransitionsInYear(utcYear) {
    const startOffsetSecs = this.getYearEndOffset(utcYear - 1);
    const endOffsetSecs = this.getYearEndOffset(utcYear);
    const startEpochSecs = isoYearToEpochSeconds(utcYear) - 1;
    const endEpochSecs = isoYearToEpochSeconds(utcYear + 1) - 1;
    if (startOffsetSecs !== endOffsetSecs) {
      return [this.searchTransition(startEpochSecs, endEpochSecs, startOffsetSecs, endOffsetSecs)];
    }
    const island = this.searchIsland(startOffsetSecs, startEpochSecs);
    if (island !== void 0) {
      return [
        this.searchTransition(startEpochSecs, island[0], startOffsetSecs, island[1]),
        this.searchTransition(island[0], endEpochSecs, island[1], endOffsetSecs)
      ];
    }
    return [];
  }
  searchTransition(startEpochSecs, endEpochSecs, startOffsetSecs, endOffsetSecs) {
    while (endEpochSecs - startEpochSecs > 1) {
      const middleEpochSecs = Math.floor(startEpochSecs + (endEpochSecs - startEpochSecs) / 2);
      const middleOffsetSecs = this.getOffset(middleEpochSecs);
      if (middleOffsetSecs === startOffsetSecs) {
        startEpochSecs = middleEpochSecs;
      } else {
        endEpochSecs = middleEpochSecs;
      }
    }
    return [
      endEpochSecs,
      startOffsetSecs,
      endOffsetSecs
    ];
  }
  searchIsland(outerOffsetSecs, startEpochSecs) {
    for (const days of ISLAND_SEARCH_DAYS) {
      const epochSecs = startEpochSecs + days * secondsInDay;
      const offsetSecs = this.getOffset(epochSecs);
      if (offsetSecs !== outerOffsetSecs) {
        return [epochSecs, offsetSecs];
      }
    }
  }
};

// src/timeZoneImpl/timeZoneImplQuery.ts
var implCache = {
  UTC: new FixedTimeZoneImpl("UTC", 0)
};
function queryTimeZoneImpl(id) {
  id = String(id);
  const key = id.toLocaleUpperCase();
  if (implCache[key]) {
    return implCache[key];
  }
  const offsetNano = tryParseOffsetNano(id);
  if (offsetNano !== void 0) {
    if (Math.abs(offsetNano) > nanoInDay) {
      throw new RangeError("Offset out of bounds");
    }
    return new FixedTimeZoneImpl(formatOffsetISO(offsetNano), Math.trunc(offsetNano / nanoInSecond));
  }
  return implCache[key] = new IntlTimeZoneImpl(id);
}

// src/public/timeZone.ts
var [getImpl, setImpl] = createWeakMap();
var TimeZone = class extends AbstractObj {
  constructor(id) {
    if (!id) {
      throw new RangeError("Invalid timezone ID");
    }
    super();
    setImpl(this, queryTimeZoneImpl(id));
  }
  static from(arg) {
    if (typeof arg === "object") {
      if (isTimeZoneArgBag(arg)) {
        return parseTimeZoneFromBag(arg.timeZone);
      } else {
        return arg;
      }
    }
    const parsed = tryParseZonedDateTime(String(arg));
    if (parsed) {
      if (parsed.timeZone) {
        const refined = refineZonedObj(parsed);
        computeEpochNanoViaOffset(refined, OFFSET_REJECT);
        return refined.timeZone;
      } else if (parsed.Z) {
        return new TimeZone("UTC");
      } else if (parsed.offset !== void 0) {
        return new TimeZone(formatOffsetISO(parsed.offset));
      }
    }
    return new TimeZone(arg);
  }
  get id() {
    return getImpl(this).id;
  }
  getOffsetStringFor(instantArg) {
    return formatOffsetISO(this.getOffsetNanosecondsFor(instantArg));
  }
  getOffsetNanosecondsFor(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    return getImpl(this).getOffset(instant.epochSeconds) * nanoInSecond;
  }
  getPlainDateTimeFor(instantArg, calendarArg = createDefaultCalendar()) {
    const instant = ensureObj(Instant, instantArg);
    const isoFields = epochNanoToISOFields(instant.epochNanoseconds + BigInt(this.getOffsetNanosecondsFor(instant)));
    return createDateTime({
      ...isoFields,
      calendar: ensureObj(Calendar, calendarArg)
    });
  }
  getInstantFor(dateTimeArg, options) {
    const disambig = parseDisambigOption(options);
    const isoFields = ensureObj(PlainDateTime, dateTimeArg).getISOFields();
    const zoneSecs = isoFieldsToEpochSecs(isoFields);
    const possibleOffsetSecs = getImpl(this).getPossibleOffsets(zoneSecs);
    let offsetSecs;
    if (possibleOffsetSecs.length === 1 || disambig === DISAMBIG_COMPATIBLE) {
      offsetSecs = possibleOffsetSecs[0];
    } else if (disambig === DISAMBIG_REJECT) {
      throw new RangeError("Ambiguous offset");
    } else {
      offsetSecs = Math[disambig === DISAMBIG_EARLIER ? "max" : "min"](...possibleOffsetSecs);
    }
    return epochSecsToInstant(zoneSecs - offsetSecs, isoFields);
  }
  getPossibleInstantsFor(dateTimeArg) {
    const isoFields = ensureObj(PlainDateTime, dateTimeArg).getISOFields();
    const zoneSecs = isoFieldsToEpochSecs(isoFields);
    let possibleOffsetSecs = getImpl(this).getPossibleOffsets(zoneSecs);
    if (possibleOffsetSecs.length === 2 && possibleOffsetSecs[0] < possibleOffsetSecs[1]) {
      possibleOffsetSecs = [];
    }
    return possibleOffsetSecs.map((offsetSecs) => epochSecsToInstant(zoneSecs - offsetSecs, isoFields));
  }
  getPreviousTransition(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    const rawTransition = getImpl(this).getTransition(instant.epochSeconds, -1);
    if (rawTransition) {
      return epochSecsToInstant(rawTransition[0]);
    }
    return null;
  }
  getNextTransition(instantArg) {
    const instant = ensureObj(Instant, instantArg);
    const rawTransition = getImpl(this).getTransition(instant.epochSeconds, 1);
    if (rawTransition) {
      return epochSecsToInstant(rawTransition[0]);
    }
    return null;
  }
  toString() {
    return this.id;
  }
};
function epochSecsToInstant(epochSecs, otherISOFields) {
  return new Instant(BigInt(epochSecs) * nanoInSecondBI + (otherISOFields ? BigInt(otherISOFields.isoMillisecond) * nanoInMilliBI + BigInt(otherISOFields.isoMicrosecond) * nanoInMicroBI + BigInt(otherISOFields.isoNanosecond) : 0n));
}

// src/argParse/timeZone.ts
function isTimeZoneArgBag(arg) {
  return arg.timeZone;
}
function parseTimeZoneFromBag(arg) {
  if (typeof arg === "object") {
    if (typeof arg.id === "string") {
      return arg;
    } else {
      throw new RangeError("Invalid timeZone");
    }
  }
  return new TimeZone(String(arg));
}
function extractTimeZone(input) {
  if (input.timeZone === void 0) {
    throw new TypeError("Must specify timeZone");
  }
  return ensureObj(TimeZone, input.timeZone);
}

// src/dateUtils/isoFieldValidation.ts
function validateYearMonth(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateDate(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  validatePlain(epochNano + (epochNano < 0n ? 86399999999999n : 0n));
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateDateTime(isoFields, calendarID) {
  const epochNano = isoFieldsToEpochNano(isoFields);
  validatePlain(epochNano);
  checkEpochNanoBuggy(epochNano, calendarID);
}
function validateInstant(epochNano) {
  if (epochNano < -8640000000000000000000n || epochNano > 8640000000000000000000n) {
    throwOutOfRange();
  }
}
function validatePlain(epochNano) {
  if (epochNano < -8640000086399999999999n || epochNano > 8640000086399999999999n) {
    throwOutOfRange();
  }
}

// src/native/intlFactory.ts
function createZonedFormatFactoryFactory(greedyDefaults, nonGreedyDefaults, finalOptions) {
  return (locales, options) => {
    const defaults = anyDefaultsOverridden(greedyDefaults, options) ? {} : { ...greedyDefaults, ...nonGreedyDefaults };
    function buildFormat2(calendarID, timeZoneID) {
      return new OrigDateTimeFormat(locales, {
        calendar: calendarID,
        timeZone: timeZoneID || void 0,
        ...defaults,
        ...options,
        ...finalOptions
      });
    }
    return {
      buildKey: createKeyFactory(locales, options, false),
      buildFormat: buildFormat2,
      buildEpochMilli: getEpochMilliFromZonedEntity
    };
  };
}
function getEpochMilliFromZonedEntity(entity) {
  return entity.epochMilliseconds;
}
function createPlainFormatFactoryFactory(greedyDefaults, finalOptions, strictCalendar) {
  return (locales, options) => {
    const defaults = anyDefaultsOverridden(greedyDefaults, options) ? {} : greedyDefaults;
    function buildFormat2(calendarID, timeZoneID) {
      return new OrigDateTimeFormat(locales, {
        calendar: calendarID,
        ...defaults,
        ...options,
        ...finalOptions,
        timeZone: timeZoneID,
        timeZoneName: void 0
      });
    }
    return {
      buildKey: createKeyFactory(locales, options, strictCalendar),
      buildFormat: buildFormat2,
      buildEpochMilli: options.timeZone !== void 0 ? computeEpochMilliViaTimeZone.bind(null, new TimeZone(options.timeZone)) : computeEpochMilliViaISO
    };
  };
}
function computeEpochMilliViaTimeZone(timeZone, entity) {
  const plainDateTime = createDateTime({
    ...zeroTimeISOFields,
    ...entity.getISOFields()
  });
  return timeZone.getInstantFor(plainDateTime).epochMilliseconds;
}
function computeEpochMilliViaISO(entity) {
  return isoFieldsToEpochMilli(entity.getISOFields());
}
function buildCachedFormatFactory(formatFactory) {
  const cachedFormats = {};
  function buildFormat2(entity, otherEntity) {
    const keys = formatFactory.buildKey(entity, otherEntity);
    const key = keys.join("|");
    return cachedFormats[key] || (cachedFormats[key] = formatFactory.buildFormat(...keys));
  }
  return {
    buildFormat: buildFormat2,
    buildEpochMilli: formatFactory.buildEpochMilli
  };
}
function createKeyFactory(locales, options, strictCalendar) {
  const optionsCalendarID = options.calendar ?? extractUnicodeCalendar(locales);
  const optionsTimeZoneID = options.timeZone;
  return function(entity, otherEntity) {
    const entityCalendarID = entity.calendar?.id;
    const entityTimeZoneID = entity.timeZone?.id;
    if (otherEntity) {
      if (otherEntity.calendar?.id !== entityCalendarID) {
        throw new RangeError("Mismatching calendar");
      }
      if (otherEntity.timeZone?.id !== entityTimeZoneID) {
        throw new RangeError("Mismatching timeZone");
      }
    }
    if ((strictCalendar || entityCalendarID !== isoCalendarID) && entityCalendarID !== void 0 && optionsCalendarID !== void 0 && optionsCalendarID !== entityCalendarID) {
      throw new RangeError("Non-iso calendar mismatch");
    }
    if (entityTimeZoneID !== void 0 && optionsTimeZoneID !== void 0 && optionsTimeZoneID !== entityTimeZoneID) {
      throw new RangeError("Given timeZone must agree");
    }
    const calendarID = optionsCalendarID || entityCalendarID || isoCalendarID;
    const timeZoneID = optionsTimeZoneID || entityTimeZoneID || "UTC";
    return [calendarID, timeZoneID];
  };
}
function extractUnicodeCalendar(locales) {
  for (const locale of locales) {
    const m = locale.match(/-u-ca-(.*)$/);
    if (m) {
      return m[1];
    }
  }
  return void 0;
}
function anyDefaultsOverridden(defaults, overrides) {
  for (const propName in defaults) {
    if (overrides[propName] !== void 0) {
      return true;
    }
  }
  return false;
}

// src/native/intlMixins.ts
function mixinLocaleStringMethods(ObjClass, buildFormatFactory) {
  ObjClass.prototype.toLocaleString = function(localesArg, options) {
    const formatFactory = buildFormatFactory(normalizeAndCopyLocalesArg(localesArg), options || {});
    return formatFactory.buildFormat(...formatFactory.buildKey(this)).format(formatFactory.buildEpochMilli(this));
  };
  ObjClass.prototype[formatFactoryFactorySymbol] = buildFormatFactory;
}
function extractFormatFactoryFactory(obj) {
  return obj?.[formatFactoryFactorySymbol];
}

// src/public/plainYearMonth.ts
var day1 = { day: 1 };
var PlainYearMonth = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, calendarArg = createDefaultCalendar(), referenceISODay = 1) {
    const constrained = constrainDateISO({
      isoYear,
      isoMonth,
      isoDay: referenceISODay
    }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateYearMonth(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainYearMonth) {
      return createYearMonth(arg.getISOFields());
    }
    if (typeof arg === "object") {
      const refinedFields = refineFields(arg, yearMonthFieldMap);
      return extractCalendar(arg).yearMonthFromFields(refinedFields, options);
    }
    const parsed = parseYearMonth(String(arg));
    if (parsed.calendar === void 0) {
      parsed.isoDay = 1;
    }
    return createYearMonth(refineBaseObj(parsed));
  }
  static compare(a, b) {
    return comparePlainYearMonths(ensureObj(PlainYearMonth, a), ensureObj(PlainYearMonth, b));
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, yearMonthFieldMap);
    return this.calendar.yearMonthFromFields(overrideYearMonthFields(refinedFields, this), options);
  }
  add(durationArg, options) {
    return addDuration(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return addDuration(this, ensureObj(Duration, durationArg).negated(), options);
  }
  until(other, options) {
    return diffDates(this.toPlainDate(day1), ensureObj(PlainYearMonth, other).toPlainDate(day1), parseDiffOptions(options, YEAR, MONTH, MONTH, YEAR));
  }
  since(other, options) {
    return diffDates(this.toPlainDate(day1), ensureObj(PlainYearMonth, other).toPlainDate(day1), parseDiffOptions(options, YEAR, MONTH, MONTH, YEAR), true);
  }
  equals(other) {
    return comparePlainYearMonths(this, ensureObj(PlainYearMonth, other)) === 0;
  }
  toString(options) {
    const fields = this.getISOFields();
    const calendarID = fields.calendar.id;
    const calendarDisplay = parseCalendarDisplayOption(options);
    return (calendarID === isoCalendarID ? formatYearMonthISO(fields) : formatDateISO(fields)) + formatCalendarID(calendarID, calendarDisplay);
  }
  toPlainDate(fields) {
    return this.calendar.dateFromFields({
      year: this.year,
      month: this.month,
      day: fields.day
    });
  }
};
mixinISOFields(PlainYearMonth);
mixinCalendarFields(PlainYearMonth, yearMonthCalendarFields);
mixinLocaleStringMethods(PlainYearMonth, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric"
}, {
  weekday: void 0,
  day: void 0,
  hour: void 0,
  minute: void 0,
  second: void 0
}, true));
function addDuration(yearMonth, duration, options) {
  return yearMonth.toPlainDate({
    day: duration.sign < 0 ? yearMonth.daysInMonth : 1
  }).add(duration, options).toPlainYearMonth();
}

// src/dateUtils/yearMonth.ts
function createYearMonth(isoFields) {
  return new PlainYearMonth(isoFields.isoYear, isoFields.isoMonth, isoFields.calendar, isoFields.isoDay);
}
function overrideYearMonthFields(overrides, base) {
  const merged = {};
  let anyYear = false;
  let anyMonth = false;
  if (overrides.era !== void 0 || overrides.eraYear !== void 0) {
    merged.era = overrides.era;
    merged.eraYear = overrides.eraYear;
    anyYear = true;
  }
  if (overrides.year !== void 0) {
    merged.year = overrides.year;
    anyYear = true;
  }
  if (!anyYear) {
    merged.year = base.year;
  }
  if (overrides.month !== void 0) {
    merged.month = overrides.month;
    anyMonth = true;
  }
  if (overrides.monthCode !== void 0) {
    merged.monthCode = overrides.monthCode;
    anyMonth = true;
  }
  if (!anyMonth) {
    merged.month = base.month;
  }
  return merged;
}
function comparePlainYearMonths(a, b) {
  return compareValues(isoFieldsToEpochNano(a.getISOFields()), isoFieldsToEpochNano(b.getISOFields())) || compareValues(a.calendar.id, b.calendar.id);
}

// src/public/zonedDateTime.ts
var [getPrivateFields, setPrivateFields] = createWeakMap();
var ZonedDateTime = class extends AbstractISOObj {
  constructor(epochNanoseconds, timeZoneArg, calendarArg = createDefaultCalendar()) {
    const timeZone = ensureObj(TimeZone, timeZoneArg);
    const calendar = ensureObj(Calendar, calendarArg);
    const instant = new Instant(epochNanoseconds);
    const offsetNanoseconds = timeZone.getOffsetNanosecondsFor(instant);
    const isoFields = epochNanoToISOFields(epochNanoseconds + BigInt(offsetNanoseconds));
    validateDateTime(isoFields, calendar.id);
    super({
      ...isoFields,
      calendar,
      timeZone,
      offset: timeZone.getOffsetStringFor(instant)
    });
    setPrivateFields(this, {
      epochNanoseconds,
      offsetNanoseconds
    });
  }
  static from(arg, options) {
    const offsetHandling = parseOffsetHandlingOption(options, OFFSET_REJECT);
    const overflowHandling = parseOverflowOption(options);
    return createZonedDateTime(arg instanceof ZonedDateTime ? {
      ...arg.getISOFields(),
      offset: arg.offsetNanoseconds
    } : typeof arg === "object" ? zonedDateTimeFieldsToISO(refineFields(arg, zonedDateTimeFieldMap), options, overflowHandling, extractCalendar(arg), extractTimeZone(arg)) : refineZonedObj(parseZonedDateTime(String(arg))), options, offsetHandling);
  }
  static compare(a, b) {
    return compareValues(ensureObj(ZonedDateTime, a).epochNanoseconds, ensureObj(ZonedDateTime, b).epochNanoseconds);
  }
  get timeZone() {
    return this.getISOFields().timeZone;
  }
  get epochNanoseconds() {
    return getPrivateFields(this).epochNanoseconds;
  }
  get offsetNanoseconds() {
    return getPrivateFields(this).offsetNanoseconds;
  }
  get offset() {
    return this.getISOFields().offset;
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, zonedDateTimeFieldMap);
    const mergedFields = overrideZonedDateTimeFields(refinedFields, this);
    const offsetHandling = parseOffsetHandlingOption(options, OFFSET_PREFER);
    const overflowHandling = parseOverflowOption(options);
    parseDisambigOption(options);
    return createZonedDateTime(zonedDateTimeFieldsToISO(mergedFields, options, overflowHandling, this.calendar, this.timeZone), options, offsetHandling);
  }
  withPlainDate(dateArg) {
    const date = ensureObj(PlainDate, dateArg);
    const dateTime = date.toPlainDateTime(this);
    const { timeZone } = this;
    const instant = timeZone.getInstantFor(dateTime);
    return new ZonedDateTime(instant.epochNanoseconds, timeZone, getStrangerCalendar(this, date));
  }
  withPlainTime(timeArg) {
    return this.toPlainDate().toZonedDateTime({
      plainTime: timeArg,
      timeZone: this.timeZone
    });
  }
  withCalendar(calendarArg) {
    return new ZonedDateTime(this.epochNanoseconds, this.timeZone, calendarArg);
  }
  withTimeZone(timeZoneArg) {
    return new ZonedDateTime(this.epochNanoseconds, timeZoneArg, this.calendar);
  }
  add(durationArg, options) {
    return addToZonedDateTime(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return addToZonedDateTime(this, ensureObj(Duration, durationArg).negated(), options);
  }
  until(other, options) {
    return diffZonedDateTimes(this, ensureObj(ZonedDateTime, other), options);
  }
  since(other, options) {
    return diffZonedDateTimes(this, ensureObj(ZonedDateTime, other), options, true);
  }
  round(options) {
    return roundZonedDateTimeWithOptions(this, options);
  }
  equals(other) {
    const otherZdt = ensureObj(ZonedDateTime, other);
    return this.epochNanoseconds === otherZdt.epochNanoseconds && this.calendar.id === otherZdt.calendar.id && this.timeZone.id === otherZdt.timeZone.id;
  }
  startOfDay() {
    return createZonedDateTime({
      ...this.getISOFields(),
      ...zeroTimeISOFields,
      offset: void 0
    }, void 0, OFFSET_REJECT);
  }
  get hoursInDay() {
    return computeNanoInDay(this) / nanoInHour;
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const offsetDisplay = parseOffsetDisplayOption(options);
    const timeZoneDisplay = parseTimeZoneDisplayOption(options);
    const calendarDisplay = parseCalendarDisplayOption(options);
    const isoFields = roundZonedDateTime(this, formatConfig.roundingIncrement, formatConfig.roundingMode).getISOFields();
    return formatDateTimeISO(isoFields, formatConfig) + (offsetDisplay === OFFSET_DISPLAY_AUTO ? isoFields.offset : "") + formatTimeZoneID(isoFields.timeZone.id, timeZoneDisplay) + formatCalendarID(isoFields.calendar.id, calendarDisplay);
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
  toPlainDateTime() {
    return createDateTime(this.getISOFields());
  }
  toPlainDate() {
    return createDate(this.getISOFields());
  }
  toPlainTime() {
    return createTime(this.getISOFields());
  }
  toInstant() {
    return new Instant(this.epochNanoseconds);
  }
};
mixinISOFields(ZonedDateTime, timeUnitNames);
mixinCalendarFields(ZonedDateTime, dateCalendarFields);
mixinEpochFields(ZonedDateTime);
mixinLocaleStringMethods(ZonedDateTime, createZonedFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {
  timeZoneName: "short"
}, {}));

// src/dateUtils/zonedDateTime.ts
function createZonedDateTime(isoFields, options, offsetHandling) {
  const { calendar, timeZone } = isoFields;
  const epochNano = computeEpochNanoViaOffset(isoFields, offsetHandling) ?? timeZone.getInstantFor(createDateTime(isoFields), options).epochNanoseconds;
  return new ZonedDateTime(epochNano, timeZone, calendar);
}
function computeEpochNanoViaOffset(isoFields, offsetHandling) {
  const { timeZone, offset, Z } = isoFields;
  let epochNano;
  if (offset !== void 0 && offsetHandling !== OFFSET_IGNORE) {
    epochNano = isoFieldsToEpochNano(isoFields) - BigInt(offset);
    if (offsetHandling !== OFFSET_USE && !Z) {
      const possibleInstants = timeZone.getPossibleInstantsFor(createDateTime(isoFields));
      if (!matchesPossibleInstants(epochNano, possibleInstants)) {
        if (offsetHandling === OFFSET_REJECT) {
          throw new RangeError("Mismatching offset/timezone");
        } else {
          epochNano = void 0;
        }
      }
    }
  }
  return epochNano;
}
function matchesPossibleInstants(epochNano, possibleInstants) {
  for (const instant of possibleInstants) {
    if (instant.epochNanoseconds === epochNano) {
      return true;
    }
  }
  return false;
}
function zonedDateTimeFieldsToISO(fields, options, overflowHandling, calendar, timeZone) {
  return {
    ...dateTimeFieldsToISO(fields, options, overflowHandling, calendar),
    timeZone,
    offset: fields.offset ? parseOffsetNano(fields.offset) : void 0
  };
}
function overrideZonedDateTimeFields(overrides, base) {
  return {
    ...overrideDateTimeFields(overrides, base),
    offset: overrides.offset ?? base.offset
  };
}
function addToZonedDateTime(zonedDateTime, duration, options) {
  const { calendar, timeZone } = zonedDateTime;
  const bigDuration = extractBigDuration(duration);
  const timeFields = durationToTimeFields(duration);
  const translated = calendar.dateAdd(zonedDateTime.toPlainDate(), bigDuration, options).toZonedDateTime({
    plainTime: zonedDateTime,
    timeZone
  });
  const timeNano = timeFieldsToNano(timeFields);
  const epochNano = translated.epochNanoseconds + timeNano;
  return new ZonedDateTime(epochNano, timeZone, calendar);
}
function diffZonedDateTimes(dt0, dt1, options, flip) {
  const diffConfig = parseDiffOptions(options, HOUR, NANOSECOND, NANOSECOND, YEAR);
  const { largestUnit } = diffConfig;
  if (largestUnit >= DAY && dt0.timeZone.id !== dt1.timeZone.id) {
    throw new Error("Must be same timeZone");
  }
  return roundBalancedDuration(diffAccurate(dt0, dt1, largestUnit), diffConfig, dt0, dt1, flip);
}
function diffAccurate(dt0, dt1, largestUnit) {
  const calendar = getCommonCalendar(dt0, dt1);
  if (!isDateUnit(largestUnit)) {
    return diffTimeScale(dt0, dt1, largestUnit);
  }
  const dateStart = createDate(dt0.getISOFields());
  let dateMiddle = createDate(dt1.getISOFields());
  let dateTimeMiddle;
  let bigDuration;
  let timeDuration;
  let bigSign;
  let timeSign;
  do {
    bigDuration = calendar.dateUntil(dateStart, dateMiddle, { largestUnit: unitNames[largestUnit] });
    dateTimeMiddle = dt0.add(bigDuration);
    timeDuration = diffTimeScale(dateTimeMiddle, dt1, HOUR);
    bigSign = bigDuration.sign;
    timeSign = timeDuration.sign;
  } while (bigSign && timeSign && bigSign !== timeSign && (dateMiddle = dateMiddle.add({ days: timeSign })));
  return addDurations(bigDuration, timeDuration);
}
function diffTimeScale(dt0, dt1, largestUnit) {
  return nanoToDuration(toNano(dt1) - toNano(dt0), largestUnit);
}
function toNano(dt) {
  if (dt instanceof PlainDateTime) {
    return isoFieldsToEpochNano(dt.getISOFields());
  }
  return dt.epochNanoseconds;
}
function roundZonedDateTimeWithOptions(zonedDateTime, options) {
  const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, DAY);
  if (roundingConfig.smallestUnit === DAY) {
    const dayTimeFields = roundTimeToSpecialDay(zonedDateTime, computeNanoInDay(zonedDateTime), roundingConfig.roundingMode);
    return createDateTime(combineISOWithDayTimeFields(zonedDateTime.getISOFields(), dayTimeFields)).toZonedDateTime(zonedDateTime.timeZone);
  }
  return roundZonedDateTime(zonedDateTime, computeRoundingNanoIncrement(roundingConfig), roundingConfig.roundingMode);
}
var zeroTimeISOFields = {
  isoHour: 0,
  isoMinute: 0,
  isoSecond: 0,
  isoMillisecond: 0,
  isoMicrosecond: 0,
  isoNanosecond: 0
};
function computeNanoInDay(zonedDateTime) {
  const isoFields = {
    ...zonedDateTime.getISOFields(),
    ...zeroTimeISOFields,
    offset: void 0
  };
  const zdt0 = createZonedDateTime(isoFields, void 0, OFFSET_REJECT);
  const zdt1 = createZonedDateTime({ ...isoFields, ...addWholeDays(isoFields, 1) }, void 0, OFFSET_REJECT);
  return Number(zdt1.epochNanoseconds - zdt0.epochNanoseconds);
}
function roundZonedDateTime(zonedDateTime, nanoIncrement, roundingFunc) {
  const dateTime = roundDateTime(zonedDateTime.toPlainDateTime(), nanoIncrement, roundingFunc);
  return createZonedDateTime({
    ...dateTime.getISOFields(),
    timeZone: zonedDateTime.timeZone,
    offset: zonedDateTime.offsetNanoseconds
  }, void 0, OFFSET_PREFER);
}

// src/dateUtils/rounding.ts
function roundBalancedDuration(balancedDuration, diffConfig, d0, d1, flip) {
  const { largestUnit, smallestUnit, roundingIncrement, roundingMode } = diffConfig;
  if (!isDateUnit(largestUnit)) {
    return nanoToDuration(roundNano((toNano(d1) - toNano(d0)) * (flip ? -1n : 1n), diffConfig), largestUnit);
  }
  let durationLike = computeExactDuration(balancedDuration, smallestUnit, d0, d1);
  const unitName = durationUnitNames[smallestUnit];
  function doRound() {
    const orig = durationLike[unitName];
    durationLike[unitName] = roundToIncrement(orig, roundingIncrement, roundingMode);
  }
  if (roundingMode === Math.round) {
    doRound();
  }
  if (flip) {
    durationLike = negateFields(durationLike);
  }
  if (roundingMode !== Math.round) {
    doRound();
  }
  let resDuration = createDuration(durationLike);
  if (smallestUnit > NANOSECOND) {
    if (flip) {
      resDuration = balanceDuration(resDuration.negated(), largestUnit, d0).negated();
    } else {
      resDuration = balanceDuration(resDuration, largestUnit, d0);
    }
  }
  return resDuration;
}
function roundTimeToSpecialDay(timeFields, ourNanoInDay, roundingFunc) {
  const nano = timeFieldsToNano(timeFields);
  return {
    day: roundingFunc(Number(nano) / ourNanoInDay),
    hour: 0,
    minute: 0,
    second: 0,
    millisecond: 0,
    microsecond: 0,
    nanosecond: 0
  };
}
function roundTime(timeFields, nanoIncrement, roundingFunc) {
  return wrapTimeOfDayNano(roundToIncrementBI(timeFieldsToNano(timeFields), nanoIncrement, roundingFunc));
}
function roundNano(nano, roundingConfig) {
  return roundToIncrementBI(nano, computeRoundingNanoIncrement(roundingConfig), roundingConfig.roundingMode);
}
function computeRoundingNanoIncrement(roundingConfig) {
  return nanoIn[roundingConfig.smallestUnit] * roundingConfig.roundingIncrement;
}
function combineISOWithDayTimeFields(isoFields, dayTimeFields) {
  const dateISOFields = addWholeDays(isoFields, dayTimeFields.day);
  return {
    ...dateISOFields,
    ...timeLikeToISO(dayTimeFields)
  };
}

// src/public/plainTime.ts
var PlainTime = class extends AbstractISOObj {
  constructor(isoHour = 0, isoMinute = 0, isoSecond = 0, isoMillisecond = 0, isoMicrosecond = 0, isoNanosecond = 0) {
    super({
      ...constrainTimeISO({
        isoHour,
        isoMinute,
        isoSecond,
        isoMillisecond,
        isoMicrosecond,
        isoNanosecond
      }, OVERFLOW_REJECT),
      calendar: createDefaultCalendar()
    });
  }
  static from(arg, options) {
    const overflowHandling = parseOverflowOption(options);
    return createTime(arg instanceof PlainTime ? arg.getISOFields() : typeof arg === "object" ? timeFieldsToConstrainedISO(refineFields(arg, timeFieldMap), overflowHandling) : parseTime(String(arg)));
  }
  static compare(a, b) {
    return compareTimes(ensureObj(PlainTime, a), ensureObj(PlainTime, b));
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, timeFieldMap);
    const mergedFields = overrideTimeFields(refinedFields, this);
    return createTime(timeFieldsToConstrainedISO(mergedFields, parseOverflowOption(options)));
  }
  add(durationArg) {
    return addToPlainTime(this, ensureObj(Duration, durationArg));
  }
  subtract(durationArg) {
    return addToPlainTime(this, ensureObj(Duration, durationArg).negated());
  }
  until(other, options) {
    return diffPlainTimes(this, ensureObj(PlainTime, other), options);
  }
  since(other, options) {
    return diffPlainTimes(ensureObj(PlainTime, other), this, options);
  }
  round(options) {
    return roundPlainTime(this, options);
  }
  equals(other) {
    return compareTimes(this, ensureObj(PlainTime, other)) === 0;
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const roundedISOFields = roundTime(this, formatConfig.roundingIncrement, formatConfig.roundingMode);
    return formatTimeISO(timeLikeToISO(roundedISOFields), formatConfig);
  }
  toZonedDateTime(options) {
    return this.toPlainDateTime(options.plainDate).toZonedDateTime(options.timeZone);
  }
  toPlainDateTime(dateArg) {
    return ensureObj(PlainDate, dateArg).toPlainDateTime(this);
  }
};
mixinISOFields(PlainTime, timeUnitNames);
mixinLocaleStringMethods(PlainTime, createPlainTimeFormatFactory);
function createPlainTimeFormatFactory(locales, options) {
  return {
    buildKey: () => ["", ""],
    buildFormat: () => new OrigDateTimeFormat(locales, {
      hour: "numeric",
      minute: "2-digit",
      second: "2-digit",
      ...options,
      timeZone: "UTC",
      timeZoneName: void 0,
      year: void 0,
      month: void 0,
      day: void 0,
      weekday: void 0
    }),
    buildEpochMilli: (plainTime) => Number(timeFieldsToNano(plainTime) / nanoInMilliBI)
  };
}

// src/dateUtils/time.ts
function createTime(isoFields) {
  return new PlainTime(isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond);
}
function constrainTimeISO({
  isoHour,
  isoMinute,
  isoSecond,
  isoMillisecond,
  isoMicrosecond,
  isoNanosecond
}, overflow) {
  isoHour = constrainInt(isoHour, 0, 23, overflow);
  isoMinute = constrainInt(isoMinute, 0, 59, overflow);
  isoSecond = constrainInt(isoSecond, 0, 59, overflow);
  isoMillisecond = constrainInt(isoMillisecond, 0, 999, overflow);
  isoMicrosecond = constrainInt(isoMicrosecond, 0, 999, overflow);
  isoNanosecond = constrainInt(isoNanosecond, 0, 999, overflow);
  return { isoHour, isoMinute, isoSecond, isoMillisecond, isoMicrosecond, isoNanosecond };
}
function overrideTimeFields(overrides, base) {
  return mapHash(timeFieldMap, (_refineFunc, fieldName) => overrides[fieldName] ?? base[fieldName]);
}
function addToPlainTime(time, dur) {
  const dayTimeFields = translateTimeOfDay(time, durationToTimeFields(dur));
  return createTime(timeLikeToISO(dayTimeFields));
}
function diffPlainTimes(t0, t1, options) {
  const diffConfig = parseDiffOptions(options, HOUR, NANOSECOND, NANOSECOND, HOUR);
  return nanoToDuration(roundNano(timeFieldsToNano(t1) - timeFieldsToNano(t0), diffConfig), diffConfig.largestUnit);
}
function roundPlainTime(plainTime, options) {
  const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, HOUR);
  const dayTimeFields = roundTime(plainTime, computeRoundingNanoIncrement(roundingConfig), roundingConfig.roundingMode);
  return createTime(timeLikeToISO(dayTimeFields));
}
function timeFieldsToConstrainedISO(fields, overflowHandling) {
  return constrainTimeISO(timeLikeToISO(fields), overflowHandling);
}
function ensureLooseTime(arg) {
  return ensureObj(PlainTime, arg ?? { hour: 0 });
}
function translateTimeOfDay(timeOfDay, delta) {
  return wrapTimeOfDayNano(timeFieldsToNano(timeOfDay) + timeFieldsToNano(delta));
}
function compareTimes(t0, t1) {
  return compareValues(timeFieldsToNano(t0), timeFieldsToNano(t1));
}
function timeFieldsToNano(timeFields) {
  return BigInt(timeFields.hour) * nanoInHourBI + BigInt(timeFields.minute) * nanoInMinuteBI + BigInt(timeFields.second) * nanoInSecondBI + BigInt(timeFields.millisecond) * nanoInMilliBI + BigInt(timeFields.microsecond) * nanoInMicroBI + BigInt(timeFields.nanosecond);
}
function timeISOToNano(timeISO) {
  return BigInt(timeISO.isoHour) * nanoInHourBI + BigInt(timeISO.isoMinute) * nanoInMinuteBI + BigInt(timeISO.isoSecond) * nanoInSecondBI + BigInt(timeISO.isoMillisecond) * nanoInMilliBI + BigInt(timeISO.isoMicrosecond) * nanoInMicroBI + BigInt(timeISO.isoNanosecond);
}
function wrapTimeOfDayNano(nano) {
  const [dayNano, timeNano] = splitEpochNano(nano);
  return {
    ...nanoToDayTimeFields(timeNano, HOUR),
    day: Number(dayNano / nanoInDayBI)
  };
}
function timeLikeToISO(fields) {
  return {
    isoNanosecond: fields.nanosecond ?? 0,
    isoMicrosecond: fields.microsecond ?? 0,
    isoMillisecond: fields.millisecond ?? 0,
    isoSecond: fields.second ?? 0,
    isoMinute: fields.minute ?? 0,
    isoHour: fields.hour ?? 0
  };
}

// src/dateUtils/dayTime.ts
function dayTimeFieldsToNano(fields) {
  return BigInt(fields.day) * nanoInDayBI + timeFieldsToNano(fields);
}
function nanoToDayTimeFields(nano, largestUnit) {
  const fields = {};
  for (let unit = largestUnit; unit >= NANOSECOND; unit--) {
    const unitNano = BigInt(nanoIn[unit]);
    const whole = nano / unitNano;
    nano -= whole * unitNano;
    fields[unitNames[unit]] = Number(whole);
  }
  return fields;
}
function splitEpochNano(epochNano) {
  const isoFields = epochNanoToISOFields(epochNano);
  return [
    isoToEpochNano(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay),
    timeISOToNano(isoFields)
  ];
}

// src/dateUtils/isoFormat.ts
function formatDateTimeISO(fields, formatConfig) {
  return formatDateISO(fields) + "T" + formatTimeISO(fields, formatConfig);
}
function formatDateISO(fields) {
  return formatYearMonthISO(fields) + "-" + padZeros(fields.isoDay, 2);
}
function formatYearMonthISO(fields) {
  const { isoYear } = fields;
  return (isoYear < 1e3 || isoYear > 9999 ? getSignStr(isoYear) + padZeros(Math.abs(isoYear), 6) : padZeros(isoYear, 4)) + "-" + padZeros(fields.isoMonth, 2);
}
function formatMonthDayISO(fields) {
  return padZeros(fields.isoMonth, 2) + "-" + padZeros(fields.isoDay, 2);
}
function formatTimeISO(fields, formatConfig) {
  const parts = [padZeros(fields.isoHour, 2)];
  if (formatConfig.smallestUnit <= MINUTE) {
    parts.push(padZeros(fields.isoMinute, 2));
    if (formatConfig.smallestUnit <= SECOND) {
      parts.push(padZeros(fields.isoSecond, 2) + formatPartialSeconds(fields.isoMillisecond, fields.isoMicrosecond, fields.isoNanosecond, formatConfig.fractionalSecondDigits)[0]);
    }
  }
  return parts.join(":");
}
function formatOffsetISO(offsetNano) {
  const fields = nanoToDayTimeFields(BigInt(Math.abs(offsetNano)), HOUR);
  const partialSecondsStr = formatPartialSeconds(fields.millisecond, fields.microsecond, fields.nanosecond, void 0)[0];
  return getSignStr(offsetNano) + padZeros(fields.hour, 2) + ":" + padZeros(fields.minute, 2) + (fields.second || partialSecondsStr ? ":" + padZeros(fields.second, 2) + partialSecondsStr : "");
}
function formatCalendarID(calendarID, display) {
  if (calendarID && (display === CALENDAR_DISPLAY_ALWAYS || display !== CALENDAR_DISPLAY_NEVER && calendarID !== isoCalendarID)) {
    return `[u-ca=${calendarID}]`;
  }
  return "";
}
function formatTimeZoneID(timeZoneID, display) {
  if (display !== TIME_ZONE_DISPLAY_NEVER) {
    return `[${timeZoneID}]`;
  }
  return "";
}
function formatDurationISO(fields, formatConfig) {
  const { smallestUnit, fractionalSecondDigits, roundingMode } = formatConfig;
  const { sign } = fields;
  const hours = BigInt(fields.hours);
  const minutes = BigInt(fields.minutes);
  let seconds = BigInt(fields.seconds);
  let partialSecondsStr = "";
  if (smallestUnit <= SECOND) {
    const res = formatPartialSeconds(fields.milliseconds, fields.microseconds, fields.nanoseconds, fractionalSecondDigits, roundingMode, smallestUnit);
    partialSecondsStr = res[0];
    seconds += BigInt(res[1]);
  }
  return (sign < 0 ? "-" : "") + "P" + collapseDurationTuples([
    [BigInt(fields.years), "Y"],
    [BigInt(fields.months), "M"],
    [BigInt(fields.weeks), "W"],
    [BigInt(fields.days), "D"]
  ]) + (hours || minutes || seconds || partialSecondsStr || !sign ? "T" + collapseDurationTuples([
    [hours, "H"],
    [minutes, "M"],
    [
      smallestUnit <= SECOND ? seconds : BigInt(0),
      partialSecondsStr + "S",
      partialSecondsStr || !sign
    ]
  ]) : "");
}
function collapseDurationTuples(tuples) {
  return tuples.map(([num, postfix, forceShow]) => {
    if (forceShow || num) {
      return (num < BigInt(0) ? -num : num) + postfix;
    }
    return "";
  }).join("");
}
function formatPartialSeconds(milliseconds, microseconds, nanoseconds, fractionalSecondDigits, roundingFunc, smallestUnit) {
  let totalNano = BigInt(nanoseconds) + BigInt(microseconds) * nanoInMicroBI + BigInt(milliseconds) * nanoInMilliBI;
  if (roundingFunc) {
    totalNano = roundToIncrementBI(totalNano, fractionalSecondDigits === void 0 ? nanoIn[smallestUnit] : Math.pow(10, 9 - fractionalSecondDigits), roundingFunc);
  }
  const totalNanoAbs = totalNano < 0 ? -totalNano : totalNano;
  const seconds = totalNanoAbs / nanoInSecondBI;
  const leftoverNano = totalNanoAbs - seconds * nanoInSecondBI;
  let afterDecimal = padZeros(Number(leftoverNano), 9);
  afterDecimal = fractionalSecondDigits === void 0 ? afterDecimal.replace(/0+$/, "") : afterDecimal.substr(0, fractionalSecondDigits);
  return [
    afterDecimal ? "." + afterDecimal : "",
    Number(seconds) * (totalNano < 0 ? -1 : 1)
  ];
}

// src/dateUtils/parseDuration.ts
function parseDuration(str) {
  const res = tryParseDuration(str);
  if (res === void 0) {
    throw createParseError("duration", str);
  }
  return res;
}
function tryParseDuration(str) {
  const match = durationRegExp.exec(normalizeDashes(str));
  if (match) {
    let hours;
    let minutes;
    let seconds;
    let leftoverNano;
    [hours, leftoverNano] = parseDurationTimeUnit(match[8], match[10], HOUR, void 0);
    [minutes, leftoverNano] = parseDurationTimeUnit(match[12], match[14], MINUTE, leftoverNano);
    [seconds, leftoverNano] = parseDurationTimeUnit(match[16], match[18], SECOND, leftoverNano);
    let fields = excludeUndefined({
      years: toIntMaybe(match[2]),
      months: toIntMaybe(match[3]),
      weeks: toIntMaybe(match[4]),
      days: toIntMaybe(match[5]),
      hours,
      minutes,
      seconds
    });
    if (!Object.keys(fields).length) {
      throw new RangeError("Duration string must have at least one field");
    }
    const small = nanoToDayTimeFields(BigInt(leftoverNano || 0), MILLISECOND);
    fields.milliseconds = small.millisecond;
    fields.microseconds = small.microsecond;
    fields.nanoseconds = small.nanosecond;
    if (match[1] === "-") {
      fields = negateFields(fields);
    }
    return fields;
  }
}
function parseDurationTimeUnit(beforeDecimal, afterDecimal, unit, leftoverNano) {
  if (beforeDecimal !== void 0) {
    if (leftoverNano !== void 0) {
      throw new RangeError("Partial units must be last unit");
    }
    return [
      parseInt(beforeDecimal),
      afterDecimal !== void 0 ? parseNanoAfterDecimal(afterDecimal) * (nanoIn[unit] / nanoInSecond) : void 0
    ];
  } else if (leftoverNano !== void 0) {
    const wholeUnits = Math.trunc(leftoverNano / nanoIn[unit]);
    return [wholeUnits, leftoverNano - wholeUnits * nanoIn[unit]];
  } else {
    return [void 0, void 0];
  }
}

// src/public/duration.ts
var [getFields, setFields] = createWeakMap();
var Duration = class extends AbstractNoValueObj {
  constructor(years = 0, months = 0, weeks = 0, days = 0, hours = 0, minutes = 0, seconds = 0, milliseconds = 0, microseconds = 0, nanoseconds = 0) {
    super();
    setFields(this, refineDurationFields({
      years,
      months,
      weeks,
      days,
      hours,
      minutes,
      seconds,
      milliseconds,
      microseconds,
      nanoseconds
    }));
  }
  static from(arg) {
    return createDuration(typeof arg === "object" ? refineFields(arg, durationFieldMap) : parseDuration(arg));
  }
  static compare(a, b, options) {
    return compareDurations(a, b, ensureOptionsObj(options).relativeTo);
  }
  get years() {
    return getFields(this).years;
  }
  get months() {
    return getFields(this).months;
  }
  get weeks() {
    return getFields(this).weeks;
  }
  get days() {
    return getFields(this).days;
  }
  get hours() {
    return getFields(this).hours;
  }
  get minutes() {
    return getFields(this).minutes;
  }
  get seconds() {
    return getFields(this).seconds;
  }
  get milliseconds() {
    return getFields(this).milliseconds;
  }
  get microseconds() {
    return getFields(this).microseconds;
  }
  get nanoseconds() {
    return getFields(this).nanoseconds;
  }
  get sign() {
    return getFields(this).sign;
  }
  get blank() {
    return !this.sign;
  }
  with(fields) {
    return createDuration({
      ...getFields(this),
      ...refineOverrideFields(fields, durationFieldMap)
    });
  }
  negated() {
    return createDuration(negateFields(getFields(this)));
  }
  abs() {
    return createDuration(mapHash(getFields(this), (num) => Math.abs(num)));
  }
  add(other, options) {
    return addAndBalanceDurations(this, ensureObj(Duration, other), ensureOptionsObj(options).relativeTo);
  }
  subtract(other, options) {
    return addAndBalanceDurations(this, ensureObj(Duration, other).negated(), ensureOptionsObj(options).relativeTo);
  }
  round(options) {
    return roundAndBalanceDuration(this, options);
  }
  total(options) {
    return computeTotalUnits(this, parseUnit(ensureOptionsObj(options).unit, void 0, NANOSECOND, YEAR), options.relativeTo);
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options, SECOND);
    return formatDurationISO(getFields(this), formatConfig);
  }
  toLocaleString(_locales, _options) {
    return this.toString();
  }
};

// src/dateUtils/duration.ts
function refineDurationFields(fields) {
  const res = {};
  let sign = 0;
  for (const fieldName of durationUnitNames) {
    const fieldVal = Number(fields[fieldName] || 0);
    const fieldSign = numSign(fields[fieldName]);
    if (fieldSign) {
      if (sign && sign !== fieldSign) {
        throw new RangeError("All fields must be same sign");
      }
      sign = fieldSign;
    }
    if (!Number.isInteger(fieldVal)) {
      throw new RangeError("Duration fields must be integers");
    }
    res[fieldName] = fieldVal;
  }
  res.sign = sign;
  return res;
}
function createDuration(fields) {
  return new Duration(fields.years, fields.months, fields.weeks, fields.days, fields.hours, fields.minutes, fields.seconds, fields.milliseconds, fields.microseconds, fields.nanoseconds);
}
function addAndBalanceDurations(d0, d1, relativeToArg) {
  const dayTimeFields0 = durationToDayTimeFields(d0);
  const dayTimeFields1 = durationToDayTimeFields(d1);
  const largestUnit = Math.max(computeLargestDurationUnit(d0), computeLargestDurationUnit(d1));
  if (relativeToArg === void 0 && dayTimeFields0 && dayTimeFields1) {
    return nanoToDuration(dayTimeFieldsToNano(dayTimeFields0) + dayTimeFieldsToNano(dayTimeFields1), largestUnit);
  }
  const relativeTo = getMaybeZonedRelativeTo(relativeToArg);
  const translated = relativeTo.add(d0).add(d1);
  return diffAccurate(relativeTo, translated, largestUnit);
}
function addDurations(d0, d1) {
  return new Duration(d0.years + d1.years, d0.months + d1.months, d0.weeks + d1.weeks, d0.days + d1.days, d0.hours + d1.hours, d0.minutes + d1.minutes, d0.seconds + d1.seconds, d0.milliseconds + d1.milliseconds, d0.microseconds + d1.microseconds, d0.nanoseconds + d1.nanoseconds);
}
function balanceDuration(duration, largestUnit, relativeTo) {
  if (relativeTo instanceof PlainDate) {
    return balanceSimpleDuration(duration, Math.max(DAY, largestUnit), relativeTo);
  } else {
    return balanceComplexDuration(duration, largestUnit, relativeTo);
  }
}
function balanceSimpleDuration(duration, largestUnit, relativeTo) {
  const translated = relativeTo.add(duration);
  return relativeTo.calendar.dateUntil(relativeTo, translated, {
    largestUnit: unitNames[largestUnit]
  });
}
function balanceComplexDuration(duration, largestUnit, relativeTo, dissolveWeeks) {
  const forcedWeeks = dissolveWeeks !== true && largestUnit > WEEK && duration.weeks;
  if (forcedWeeks) {
    duration = duration.with({ weeks: 0 });
  }
  const translated = relativeTo.add(duration);
  let balancedDuration = diffAccurate(relativeTo, translated, largestUnit);
  if (forcedWeeks) {
    balancedDuration = addDurations(balancedDuration, new Duration(0, 0, forcedWeeks));
  }
  return balancedDuration;
}
function roundAndBalanceDuration(duration, options) {
  if (!isObjectLike(options)) {
    throw new TypeError("Must specify options");
  } else if (options.largestUnit === void 0 && options.smallestUnit === void 0) {
    throw new RangeError("Must specify either largestUnit or smallestUnit");
  }
  const defaultLargestUnit = computeLargestDurationUnit(duration);
  const diffConfig = parseDiffOptions(options, defaultLargestUnit, NANOSECOND, NANOSECOND, YEAR, false, true);
  const { largestUnit, smallestUnit } = diffConfig;
  const dayTimeFields = durationToDayTimeFields(duration);
  if (options.relativeTo === void 0 && dayTimeFields && isDayTimeUnit(largestUnit) && isDayTimeUnit(smallestUnit)) {
    const nano = roundNano(dayTimeFieldsToNano(dayTimeFields), diffConfig);
    const roundedFields = nanoToDayTimeFields(nano, largestUnit);
    return dayTimeFieldsToDuration(roundedFields);
  }
  const relativeTo = extractRelativeTo(options.relativeTo);
  const balancedDuration = balanceComplexDuration(duration, largestUnit, relativeTo);
  return roundBalancedDuration(balancedDuration, diffConfig, relativeTo, relativeTo.add(balancedDuration));
}
function computeLargestDurationUnit(dur) {
  return dur.years ? YEAR : dur.months ? MONTH : dur.weeks ? WEEK : dur.days ? DAY : dur.hours ? HOUR : dur.minutes ? MINUTE : dur.seconds ? SECOND : dur.milliseconds ? MILLISECOND : dur.microseconds ? MICROSECOND : NANOSECOND;
}
function compareDurations(arg0, arg1, relativeToArg) {
  const duration0 = ensureObj(Duration, arg0);
  const duration1 = ensureObj(Duration, arg1);
  const dayTimeFields0 = durationToDayTimeFields(duration0);
  const dayTimeFields1 = durationToDayTimeFields(duration1);
  if (relativeToArg === void 0 && dayTimeFields0 && dayTimeFields1) {
    return compareValues(dayTimeFieldsToNano(dayTimeFields0), dayTimeFieldsToNano(dayTimeFields1));
  }
  const relativeTo = getMaybeZonedRelativeTo(relativeToArg);
  const date0 = relativeTo.add(duration0);
  const date1 = relativeTo.add(duration1);
  if (relativeTo instanceof ZonedDateTime) {
    return ZonedDateTime.compare(date0, date1);
  }
  return PlainDateTime.compare(date0, date1);
}
function nanoToDuration(nano, largestUnit) {
  return dayTimeFieldsToDuration(nanoToDayTimeFields(nano, largestUnit));
}
function dayTimeFieldsToDuration(fields) {
  return new Duration(0, 0, 0, fields.day, fields.hour, fields.minute, fields.second, fields.millisecond, fields.microsecond, fields.nanosecond);
}
function durationToDayTimeFields(duration) {
  if (!duration.years && !duration.months && !duration.weeks) {
    return {
      day: duration.days,
      ...durationToTimeFields(duration)
    };
  }
}
function extractDurationTimeFields(duration) {
  const timeNano = timeFieldsToNano(durationToTimeFields(duration));
  const days = timeNano / nanoInDayBI;
  const leftoverTimeNano = timeNano - days * nanoInDayBI;
  return [
    nanoToDayTimeFields(leftoverTimeNano, HOUR),
    new Duration(duration.years, duration.months, duration.weeks, duration.days + Number(days))
  ];
}
function extractBigDuration(duration) {
  return new Duration(duration.years, duration.months, duration.weeks, duration.days);
}
function durationToTimeFields(duration) {
  return {
    hour: duration.hours,
    minute: duration.minutes,
    second: duration.seconds,
    millisecond: duration.milliseconds,
    microsecond: duration.microseconds,
    nanosecond: duration.nanoseconds
  };
}
function getMaybeZonedRelativeTo(arg) {
  if (arg === void 0) {
    throw new RangeError("Need relativeTo");
  } else if (typeof arg === "object") {
    if (arg.timeZone !== void 0) {
      return ZonedDateTime.from(arg);
    } else {
      return PlainDateTime.from(arg);
    }
  } else {
    const isoFields = parseZonedDateTime(String(arg));
    if (isoFields.timeZone !== void 0) {
      return createZonedDateTime(refineZonedObj(isoFields), void 0, OFFSET_PREFER);
    } else {
      return createDateTime(refineBaseObj(isoFields));
    }
  }
}
function extractRelativeTo(arg) {
  if (arg === void 0) {
    throw new RangeError("Must specify relativeTo");
  }
  if (isObjectLike(arg)) {
    if (arg instanceof ZonedDateTime || arg instanceof PlainDateTime) {
      return arg;
    }
    return ensureObj(arg.timeZone !== void 0 ? ZonedDateTime : PlainDateTime, arg);
  }
  if (typeof arg === "symbol") {
    throw new TypeError("Incorrect relativeTo type");
  }
  const parsed = tryParseZonedDateTime(String(arg));
  if (parsed) {
    if (parsed.timeZone !== void 0) {
      return createZonedDateTime(refineZonedObj(parsed), void 0, OFFSET_REJECT);
    } else {
      return createDateTime(refineBaseObj(parsed));
    }
  }
  throw new RangeError("Invalid value of relativeTo");
}
function negateFields(fields) {
  return mapHash(fields, (num) => -num || 0);
}

// src/dateUtils/add.ts
function addToDateFields(dateFields, duration, calendarImpl, overflowHandling) {
  dateFields = addWholeYears(dateFields, duration.years, calendarImpl, overflowHandling);
  dateFields = addWholeMonths(dateFields, duration.months, calendarImpl, overflowHandling);
  let epochMilli = calendarImpl.epochMilliseconds(dateFields.year, dateFields.month, dateFields.day);
  const [, bigDuration] = extractDurationTimeFields(duration);
  epochMilli = addDaysMilli(epochMilli, bigDuration.weeks * 7 + bigDuration.days);
  return epochMilliToISOFields(epochMilli);
}
function addWholeYears({ year, month, day }, yearsToAdd, calendarImpl, overflowHandling) {
  year += yearsToAdd;
  const newMonth = constrainInt(month, 1, calendarImpl.monthsInYear(year), overflowHandling);
  let newDay = month === newMonth ? day : 1;
  newDay = constrainInt(newDay, 1, calendarImpl.daysInMonth(year, newMonth), overflowHandling);
  return { year, month: newMonth, day: newDay };
}
function addWholeMonths({ year, month, day }, monthsToAdd, calendarImpl, overflowHandling) {
  if (monthsToAdd) {
    month += monthsToAdd;
    if (monthsToAdd < 0) {
      while (month < 1) {
        month += calendarImpl.monthsInYear(--year);
      }
    } else {
      let monthsInYear;
      while (month > (monthsInYear = calendarImpl.monthsInYear(year))) {
        month -= monthsInYear;
        year++;
      }
    }
    day = constrainInt(day, 1, calendarImpl.daysInMonth(year, month), overflowHandling);
  }
  return { year, month, day };
}
function addWholeDays(fields, days) {
  if (days) {
    return {
      ...epochMilliToISOFields(addDaysMilli(isoFieldsToEpochMilli(fields), days)),
      calendar: fields.calendar
    };
  }
  return fields;
}

// src/public/plainMonthDay.ts
var PlainMonthDay = class extends AbstractISOObj {
  constructor(isoMonth, isoDay, calendar = createDefaultCalendar(), referenceISOYear) {
    const isoYear = referenceISOYear ?? (calendar.id === isoCalendarID ? isoEpochLeapYear : throwNew(Error, "Must specify referenceYear"));
    super({
      ...constrainDateISO({ isoYear, isoMonth, isoDay }, OVERFLOW_REJECT),
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainMonthDay) {
      return createMonthDay(arg.getISOFields());
    }
    if (typeof arg === "object") {
      const calendar = extractCalendar(arg);
      let refinedFields = refineFields(arg, monthDayFieldMap);
      if (refinedFields.year === void 0 && arg.calendar === void 0) {
        refinedFields = { ...refinedFields, year: isoEpochLeapYear };
      }
      return calendar.monthDayFromFields(refinedFields, options);
    }
    const parsed = parseMonthDay(String(arg));
    if (parsed.calendar === void 0) {
      parsed.isoYear = isoEpochLeapYear;
    }
    return createMonthDay(refineBaseObj(parsed));
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, monthDayFieldMap);
    const mergedFields = overrideMonthDayFields(refinedFields, this);
    return this.calendar.monthDayFromFields(mergedFields, options);
  }
  equals(other) {
    return monthDaysEqual(this, ensureObj(PlainMonthDay, other));
  }
  toString(options) {
    const fields = this.getISOFields();
    const calendarID = fields.calendar.id;
    const calendarDisplay = parseCalendarDisplayOption(options);
    return (calendarID === isoCalendarID ? formatMonthDayISO(fields) : formatDateISO(fields)) + formatCalendarID(calendarID, calendarDisplay);
  }
  toPlainDate(fields, options) {
    return this.calendar.dateFromFields({
      year: fields.year,
      monthCode: this.monthCode,
      day: this.day
    }, options);
  }
};
mixinISOFields(PlainMonthDay);
mixinCalendarFields(PlainMonthDay, monthDayCalendarFields);
mixinLocaleStringMethods(PlainMonthDay, createPlainFormatFactoryFactory({
  month: "numeric",
  day: "numeric"
}, {
  weekday: void 0,
  year: void 0,
  hour: void 0,
  minute: void 0,
  second: void 0
}, true));

// src/dateUtils/monthDay.ts
var monthDayFieldMap = {
  era: String,
  eraYear: Number,
  year: Number,
  month: Number,
  monthCode: String,
  day: Number
};
function createMonthDay(isoFields) {
  return new PlainMonthDay(isoFields.isoMonth, isoFields.isoDay, isoFields.calendar, isoFields.isoYear);
}
function overrideMonthDayFields(overrides, base) {
  const merged = { day: overrides.day ?? base.day };
  if (overrides.monthCode !== void 0) {
    merged.monthCode = overrides.monthCode;
    if (overrides.month !== void 0) {
      merged.month = overrides.month;
    }
  } else if (overrides.month !== void 0) {
    merged.month = overrides.month;
    merged.year = overrides.year;
  } else {
    merged.monthCode = base.monthCode;
  }
  return merged;
}
function monthDaysEqual(a, b) {
  return a.calendar.id === b.calendar.id && isoFieldsToEpochNano(a.getISOFields()) === isoFieldsToEpochNano(b.getISOFields());
}
function compareMonthDayFields(d0, d1) {
  return compareValues(d0.month, d1.month) || compareValues(d0.day, d1.day);
}

// src/dateUtils/date.ts
function createDate(isoFields) {
  return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.calendar);
}
function overrideDateFields(overrides, base) {
  return {
    ...overrideYearMonthFields(overrides, base),
    day: overrides.day ?? base.day
  };
}
function constrainDateFields(year, month, day, calendarImpl, overflow) {
  year = Number(year);
  month = constrainInt(month, 1, calendarImpl.monthsInYear(year), overflow);
  day = constrainInt(day, 1, calendarImpl.daysInMonth(year, month), overflow);
  return [year, month, day];
}
function constrainDateISO(isoFields, overflow) {
  const [isoYear, isoMonth, isoDay] = constrainDateFields(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoCalendarImpl, overflow);
  return { isoYear, isoMonth, isoDay };
}
function compareDates(a, b) {
  return compareValues(isoFieldsToEpochNano(a.getISOFields()), isoFieldsToEpochNano(b.getISOFields())) || compareValues(a.calendar.id, b.calendar.id);
}
function compareDateFields(d0, d1) {
  return compareValues(d0.year, d1.year) || compareMonthDayFields(d0, d1);
}
function diffDates(d0, d1, diffConfig, flip) {
  const calendar = getCommonCalendar(d0, d1);
  const balancedDuration = calendar.dateUntil(d0, d1, {
    largestUnit: unitNames[diffConfig.largestUnit]
  });
  return roundBalancedDuration(balancedDuration, diffConfig, d0, d1, flip);
}

// src/public/plainDate.ts
var PlainDate = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, isoDay, calendarArg = createDefaultCalendar()) {
    const constrained = constrainDateISO({ isoYear, isoMonth, isoDay }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateDate(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    parseOverflowOption(options);
    if (arg instanceof PlainDate) {
      return createDate(arg.getISOFields());
    }
    if (typeof arg === "object") {
      const refinedFields = refineFields(arg, dateFieldMap);
      return extractCalendar(arg).dateFromFields(refinedFields, options);
    }
    return createDate(refineBaseObj(parseDateTime(String(arg))));
  }
  static compare(a, b) {
    return compareDates(ensureObj(PlainDate, a), ensureObj(PlainDate, b));
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, dateFieldMap);
    const mergedFields = overrideDateFields(refinedFields, this);
    return this.calendar.dateFromFields(mergedFields, options);
  }
  withCalendar(calendarArg) {
    const isoFields = this.getISOFields();
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, calendarArg);
  }
  add(durationArg, options) {
    return this.calendar.dateAdd(this, durationArg, options);
  }
  subtract(durationArg, options) {
    return this.calendar.dateAdd(this, ensureObj(Duration, durationArg).negated(), options);
  }
  until(other, options) {
    return diffDates(this, ensureObj(PlainDate, other), parseDiffOptions(options, DAY, DAY, DAY, YEAR));
  }
  since(other, options) {
    return diffDates(this, ensureObj(PlainDate, other), parseDiffOptions(options, DAY, DAY, DAY, YEAR), true);
  }
  equals(other) {
    return compareDates(this, ensureObj(PlainDate, other)) === 0;
  }
  toString(options) {
    const calendarDisplay = parseCalendarDisplayOption(options);
    const fields = this.getISOFields();
    return formatDateISO(fields) + formatCalendarID(fields.calendar.id, calendarDisplay);
  }
  toZonedDateTime(options) {
    return this.toPlainDateTime(options.plainTime).toZonedDateTime(options.timeZone);
  }
  toPlainDateTime(timeArg) {
    return createDateTime({
      ...this.getISOFields(),
      ...ensureLooseTime(timeArg).getISOFields()
    });
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
};
mixinISOFields(PlainDate);
mixinCalendarFields(PlainDate, dateCalendarFields);
mixinLocaleStringMethods(PlainDate, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0
}, {
  hour: void 0,
  minute: void 0,
  second: void 0
}));

// src/dateUtils/calendar.ts
function isDateISOInstance(arg) {
  return arg instanceof PlainDate || arg instanceof PlainDateTime || arg instanceof ZonedDateTime || arg instanceof PlainYearMonth || arg instanceof PlainMonthDay;
}
function queryDateFields(arg, calendar, disallowMonthDay) {
  let date;
  if (arg instanceof PlainDate) {
    date = arg;
  } else if (isDateISOInstance(arg)) {
    if (disallowMonthDay && arg instanceof PlainMonthDay) {
      throw new TypeError("PlainMonthDay not allowed");
    }
    date = createDate(arg.getISOFields());
  } else {
    date = PlainDate.from(arg);
  }
  ensureCalendarsEqual(date.calendar, calendar);
  return date;
}
function queryDateISOFields(dateLike, calendarImpl, options) {
  if (isDateISOInstance(dateLike)) {
    return dateLike.getISOFields();
  }
  let { era, eraYear, year, month, monthCode, day } = dateLike;
  const yearFromEra = eraYear !== void 0 && era !== void 0 ? convertEraYear(calendarImpl.id, eraYear, era) : void 0;
  if (year === void 0) {
    if (yearFromEra !== void 0) {
      year = yearFromEra;
    } else {
      throw new TypeError("Must specify either a year or an era & eraYear");
    }
  } else {
    if (yearFromEra !== void 0) {
      if (yearFromEra !== year) {
        throw new RangeError("year and era/eraYear must match");
      }
    }
  }
  if (day === void 0) {
    throw new TypeError("Must specify day");
  }
  const overflow = parseOverflowOption(options);
  if (monthCode !== void 0) {
    const [tryMonth, unusedLeap] = calendarImpl.convertMonthCode(monthCode, year);
    if (month !== void 0 && month !== tryMonth) {
      throw new RangeError("Month doesnt match with monthCode");
    }
    month = tryMonth;
    if (unusedLeap) {
      if (overflow === OVERFLOW_REJECT) {
        throw new RangeError("Month code out of range");
      }
      day = calendarImpl.daysInMonth(year, month);
    }
  } else if (month === void 0) {
    throw new TypeError("Must specify either a month or monthCode");
  }
  [year, month, day] = constrainDateFields(year, month, day, calendarImpl, overflow);
  return epochMilliToISOFields(calendarImpl.epochMilliseconds(year, month, day));
}
function getExistingDateISOFields(dateArg, disallowMonthDay) {
  if (isDateISOInstance(dateArg)) {
    if (disallowMonthDay && dateArg instanceof PlainMonthDay) {
      throw new TypeError("PlainMonthDay not allowed");
    }
    return dateArg.getISOFields();
  } else {
    return PlainDate.from(dateArg).getISOFields();
  }
}
function computeDaysInYear(calendarImpl, year) {
  return diffDaysMilli(calendarImpl.epochMilliseconds(year, 1, 1), calendarImpl.epochMilliseconds(year + 1, 1, 1));
}
function computeDayOfYear(calendarImpl, year, month, day) {
  return diffDaysMilli(calendarImpl.epochMilliseconds(year, 1, 1), calendarImpl.epochMilliseconds(year, month, day)) + 1;
}

// src/calendarImpl/intlCalendarImpl.ts
var calLeapMonths = {
  hebrew: 6,
  chinese: 0,
  dangi: 0
};
var IntlCalendarImpl = class extends CalendarImpl {
  constructor(id) {
    const format = buildFormat(id);
    if (!isRelatedCalendar(id, format.resolvedOptions().calendar)) {
      throw new RangeError("Invalid calendar: " + id);
    }
    super(id);
    this.format = format;
    this.yearCorrection = this.computeFieldsDumb(0).year - isoEpochOriginYear;
    this.monthCacheByYear = {};
  }
  epochMilliseconds(year, month, day) {
    const epochMillis = this.queryMonthCache(year)[0];
    const marker = epochMillis[month - 1];
    return addDaysMilli(marker, day - 1);
  }
  daysInMonth(year, month) {
    const epochMillis = this.queryMonthCache(year)[0];
    const startMarker = epochMillis[month - 1];
    if (month >= epochMillis.length) {
      year++;
      month = 0;
    }
    const endMarker = this.queryMonthCache(year)[0][month];
    return diffDaysMilli(startMarker, endMarker);
  }
  monthsInYear(year) {
    const epochMillis = this.queryMonthCache(year)[0];
    return epochMillis.length;
  }
  monthCode(month, year) {
    const leapMonth = this.queryLeapMonthByYear(year);
    if (!leapMonth || month < leapMonth) {
      return super.monthCode(month, year);
    }
    return super.monthCode(month - 1, year) + (month === leapMonth ? "L" : "");
  }
  convertMonthCode(monthCode, year) {
    const leapMonth = this.queryLeapMonthByYear(year);
    let monthCodeIsLeap = /L$/.test(monthCode);
    let monthCodeInt = parseInt(monthCode.substr(1));
    let unusedLeap = false;
    if (monthCodeIsLeap) {
      const presetLeapMonth = calLeapMonths[this.id];
      if (presetLeapMonth === void 0) {
        throw new RangeError("Calendar system doesnt support leap months");
      }
      if (presetLeapMonth) {
        if (monthCodeInt !== presetLeapMonth - 1) {
          throw new RangeError("Invalid leap-month month code");
        }
      } else {
        if (monthCodeInt <= 1 || monthCodeInt >= 12) {
          throw new RangeError("Invalid leap-month month code");
        }
      }
    }
    if (monthCodeIsLeap && !(leapMonth && monthCodeInt === leapMonth - 1)) {
      unusedLeap = true;
      monthCodeIsLeap = false;
    }
    if (monthCodeIsLeap || leapMonth && monthCodeInt >= leapMonth) {
      monthCodeInt++;
    }
    return [monthCodeInt, unusedLeap];
  }
  inLeapYear(year) {
    const days = computeDaysInYear(this, year);
    return days > computeDaysInYear(this, year - 1) && days > computeDaysInYear(this, year + 1);
  }
  guessYearForMonthDay(monthCode, day) {
    let year = isoEpochOriginYear + this.yearCorrection;
    const maxYear = year + 100;
    for (; year < maxYear; year++) {
      const [month, unusedLeap] = this.convertMonthCode(monthCode, year);
      if (!unusedLeap && month <= this.monthsInYear(year) && day <= this.daysInMonth(year, month)) {
        return year;
      }
    }
    throw new Error("Could not guess year");
  }
  normalizeISOYearForMonthDay(isoYear) {
    return isoYear;
  }
  computeFields(epochMilli) {
    const dumbFields = this.computeFieldsDumb(epochMilli);
    const monthStrToNum = this.queryMonthCache(dumbFields.year)[2];
    return {
      ...dumbFields,
      month: monthStrToNum[dumbFields.month]
    };
  }
  computeFieldsDumb(epochMilli) {
    const partHash = hashIntlFormatParts(this.format, epochMilli);
    let era;
    let eraYear;
    let year = parseInt(partHash.relatedYear || partHash.year);
    if (partHash.era && hasEras(this.id)) {
      era = normalizeShortEra(partHash.era);
      eraYear = year;
      year = convertEraYear(this.id, eraYear, era, true);
    }
    return {
      era,
      eraYear,
      year,
      month: partHash.month,
      day: parseInt(partHash.day)
    };
  }
  queryLeapMonthByYear(year) {
    const currentCache = this.queryMonthCache(year);
    const prevCache = this.queryMonthCache(year - 1);
    const nextCache = this.queryMonthCache(year + 1);
    if (currentCache[0].length > prevCache[0].length && currentCache[0].length > nextCache[0].length) {
      const currentMonthStrs = currentCache[1];
      const prevMonthStrs = prevCache[1];
      for (let i = 0; i < prevMonthStrs.length; i++) {
        if (prevMonthStrs[i] !== currentMonthStrs[i]) {
          return i + 1;
        }
      }
    }
    return void 0;
  }
  queryMonthCache(year) {
    const { monthCacheByYear } = this;
    return monthCacheByYear[year] || (monthCacheByYear[year] = this.buildMonthCache(year));
  }
  buildMonthCache(year) {
    const epochMillis = [];
    const monthStrs = [];
    const monthStrToNum = {};
    let epochMilli = isoToEpochMilli(this.guessISOYear(year));
    epochMilli = addDaysMilli(epochMilli, 400);
    while (true) {
      const fields = this.computeFieldsDumb(epochMilli);
      if (fields.year < year) {
        break;
      }
      epochMilli = addDaysMilli(epochMilli, 1 - fields.day);
      if (fields.year === year) {
        epochMillis.unshift(epochMilli);
        monthStrs.unshift(fields.month);
      }
      epochMilli = addDaysMilli(epochMilli, -1);
    }
    for (let i = 0; i < monthStrs.length; i++) {
      monthStrToNum[monthStrs[i]] = i + 1;
    }
    return [epochMillis, monthStrs, monthStrToNum];
  }
  guessISOYear(year) {
    return year - this.yearCorrection;
  }
};
function buildFormat(calendarID) {
  return new OrigDateTimeFormat("en-US", {
    calendar: calendarID,
    era: "short",
    year: "numeric",
    month: "short",
    day: "numeric",
    timeZone: "UTC"
  });
}
function isRelatedCalendar(specificCalendarID, relatedCalendarID) {
  return getCalendarIDBase(specificCalendarID) === getCalendarIDBase(relatedCalendarID);
}

// src/calendarImpl/islamicCalendarImpl.ts
var IslamicCalendarImpl = class extends IntlCalendarImpl {
  guessISOYear(year) {
    return Math.ceil(year * 32 / 33 + 622);
  }
};

// src/calendarImpl/japaneseCalendarImpl.ts
var primaryEraMilli = isoToEpochMilli(1868, 9, 8);
var JapaneseCalendarImpl = class extends GregoryCalendarImpl {
  constructor() {
    super(...arguments);
    this.format = buildFormat("japanese");
  }
  computeFields(epochMilli) {
    const fields = super.computeFields(epochMilli);
    if (epochMilli >= primaryEraMilli) {
      const partHash = hashIntlFormatParts(this.format, epochMilli);
      fields.era = normalizeShortEra(partHash.era);
      fields.eraYear = parseInt(partHash.relatedYear || partHash.year);
    }
    return fields;
  }
};

// src/calendarImpl/calendarImplQuery.ts
var implClasses = {
  gregory: GregoryCalendarImpl,
  japanese: JapaneseCalendarImpl,
  islamic: IslamicCalendarImpl
};
var implCache2 = {
  [isoCalendarID]: isoCalendarImpl
};
function queryCalendarImpl(id) {
  id = String(id);
  const key = id.toLocaleLowerCase();
  return implCache2[key] || (implCache2[key] = new (implClasses[getCalendarIDBase(key)] || IntlCalendarImpl)(id));
}

// src/calendarImpl/bugs.ts
var good1582 = isoToEpochMilli(1582, 10, 15);
var goodIslamic = isoToEpochMilli(622, 7, 18);
var goodEpochMillis = {
  buddhist: good1582,
  japanese: good1582,
  roc: good1582,
  islamic: goodIslamic,
  "islamic-rgsa": goodIslamic,
  indian: 0
};
var hasBugByID = {};
function checkEpochNanoBuggy(epochNano, calendarID) {
  return checkEpochMilliBuggy(Number(epochNano / nanoInMilliBI), calendarID);
}
function checkEpochMilliBuggy(epochMilli, calendarID) {
  if (isEpochMilliBuggy(epochMilli, calendarID)) {
    throw new RangeError("Invalid timestamp for calendar");
  }
}
function isEpochMilliBuggy(epochMilli, calendarID) {
  return hasEpochMilliBug(calendarID) && epochMilli < goodEpochMillis[calendarID];
}
function hasEpochMilliBug(calendarID) {
  let hasBug = hasBugByID[calendarID];
  if (hasBug === void 0) {
    const goodEpochMilli = goodEpochMillis[calendarID];
    if (goodEpochMilli === void 0) {
      hasBug = false;
    } else {
      let impl = queryCalendarImpl(calendarID);
      if (!(impl instanceof IntlCalendarImpl)) {
        impl = new IntlCalendarImpl(calendarID);
      }
      const badEpochMilli = goodEpochMilli - milliInDay;
      const fields = impl.computeFields(badEpochMilli);
      hasBug = badEpochMilli !== impl.epochMilliseconds(fields.year, fields.month, fields.day);
    }
    hasBugByID[calendarID] = hasBug;
  }
  return hasBug;
}

// src/dateUtils/diff.ts
function diffDateFields(d0, d1, calendarImpl, largestUnit) {
  let years = 0;
  let months = 0;
  let weeks = 0;
  let days = 0;
  switch (largestUnit) {
    case YEAR:
      years = wholeYearsUntil(d0, d1, calendarImpl);
      d0 = addWholeYears(d0, years, calendarImpl, OVERFLOW_CONSTRAIN);
    case MONTH:
      months = wholeMonthsUntil(d0, d1, calendarImpl);
      d0 = addWholeMonths(d0, months, calendarImpl, OVERFLOW_CONSTRAIN);
  }
  days = diffDaysMilli(calendarImpl.epochMilliseconds(d0.year, d0.month, d0.day), calendarImpl.epochMilliseconds(d1.year, d1.month, d1.day));
  if (largestUnit === WEEK) {
    weeks = Math.trunc(days / 7);
    days %= 7;
  }
  return new Duration(years, months, weeks, days);
}
function wholeYearsUntil(d0, d1, calendarImpl) {
  const [, newMonth, newDay] = constrainDateFields(d1.year, d0.month, d0.day, calendarImpl, OVERFLOW_CONSTRAIN);
  const generalSign = compareDateFields(d1, d0);
  const monthSign = compareValues(d1.month, newMonth) || compareValues(d1.day, newDay);
  return d1.year - d0.year - (monthSign && generalSign && monthSign !== generalSign ? generalSign : 0);
}
function wholeMonthsUntil(d0, d1, calendarImpl) {
  let monthsToAdd = 0;
  const generalSign = compareDateFields(d1, d0);
  if (generalSign) {
    let { year } = d0;
    while (year !== d1.year) {
      monthsToAdd += calendarImpl.monthsInYear(year) * generalSign;
      year += generalSign;
    }
    const [, newMonth, newDay] = constrainDateFields(d1.year, d0.month, d0.day, calendarImpl, OVERFLOW_CONSTRAIN);
    monthsToAdd += d1.month - newMonth;
    const daySign = compareValues(d1.day, newDay);
    if (daySign && generalSign && daySign !== generalSign) {
      monthsToAdd -= generalSign;
    }
  }
  return monthsToAdd;
}

// src/dateUtils/week.ts
function computeWeekOfISOYear(isoYear, isoMonth, isoDay, firstDay, minimalDays) {
  const weekOffset = computeFirstWeekOffset(isoYear, firstDay, minimalDays);
  const week = Math.floor((computeDayOfYear(isoCalendarImpl, isoYear, isoMonth, isoDay) - weekOffset - 1) / 7) + 1;
  if (week < 1) {
    return week + computeWeeksInISOYear(isoYear - 1, firstDay, minimalDays);
  }
  const weeksYear = computeWeeksInISOYear(isoYear, firstDay, minimalDays);
  if (week > weeksYear) {
    return week - weeksYear;
  }
  return week;
}
function computeFirstWeekOffset(isoYear, firstDay, minimalDays) {
  const firstWeekDay = 7 + firstDay - minimalDays;
  const localWeek = positiveModulo(computeISODayOfWeek(isoYear, 1, firstWeekDay) - firstDay, 7);
  return -localWeek + firstWeekDay - 1;
}
function computeWeeksInISOYear(isoYear, firstDay, minimalDays) {
  const weekOffset = computeFirstWeekOffset(isoYear, firstDay, minimalDays);
  const weekOffsetNext = computeFirstWeekOffset(isoYear + 1, firstDay, minimalDays);
  return (computeDaysInYear(isoCalendarImpl, isoYear) - weekOffset + weekOffsetNext) / 7;
}

// src/public/calendar.ts
var [getImpl2, setImpl2] = createWeakMap();
var Calendar = class extends AbstractObj {
  constructor(id) {
    super();
    if (id === "islamicc") {
      id = "islamic-civil";
    }
    setImpl2(this, queryCalendarImpl(id));
  }
  static from(arg) {
    if (typeof arg === "object" && arg) {
      if (isCalendarArgBag(arg)) {
        return parseCalendarArgFromBag(arg.calendar);
      } else {
        return arg;
      }
    }
    const parsed = tryParseDateTime(String(arg));
    return new Calendar(parsed ? parsed.calendar || isoCalendarID : arg);
  }
  get id() {
    return getImpl2(this).id;
  }
  era(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).era;
  }
  eraYear(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).eraYear;
  }
  year(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).year;
  }
  month(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).month;
  }
  monthCode(arg) {
    const fields = queryDateFields(arg, this);
    return getImpl2(this).monthCode(fields.month, fields.year);
  }
  day(arg) {
    const isoFields = getExistingDateISOFields(arg);
    return isoToEpochNanoSafe(getImpl2(this), isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay).day;
  }
  dayOfWeek(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return computeISODayOfWeek(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay);
  }
  dayOfYear(arg) {
    const fields = queryDateFields(arg, this, true);
    return computeDayOfYear(getImpl2(this), fields.year, fields.month, fields.day);
  }
  weekOfYear(arg) {
    const isoFields = getExistingDateISOFields(arg, true);
    return computeWeekOfISOYear(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, 1, 4);
  }
  daysInWeek(arg) {
    getExistingDateISOFields(arg, true);
    return 7;
  }
  daysInMonth(arg) {
    const fields = queryDateFields(arg, this, true);
    return getImpl2(this).daysInMonth(fields.year, fields.month);
  }
  daysInYear(arg) {
    const fields = queryDateFields(arg, this, true);
    return computeDaysInYear(getImpl2(this), fields.year);
  }
  monthsInYear(arg) {
    const calFields = queryDateFields(arg, this, true);
    return getImpl2(this).monthsInYear(calFields.year);
  }
  inLeapYear(arg) {
    return getImpl2(this).inLeapYear(this.year(arg));
  }
  dateFromFields(arg, options) {
    const isoFields = queryDateISOFields(arg, getImpl2(this), options);
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, this);
  }
  yearMonthFromFields(arg, options) {
    const isoFields = queryDateISOFields({ ...arg, day: 1 }, getImpl2(this), options);
    return new PlainYearMonth(isoFields.isoYear, isoFields.isoMonth, this, isoFields.isoDay);
  }
  monthDayFromFields(fields, options) {
    const impl = getImpl2(this);
    let { era, eraYear, year, month, monthCode, day } = fields;
    if (day === void 0) {
      throw new TypeError("required property 'day' missing or undefined");
    }
    if (monthCode !== void 0) {
      year = isoEpochLeapYear;
    } else if (era !== void 0 && eraYear !== void 0) {
      year = convertEraYear(impl.id, eraYear, era);
    }
    if (year === void 0) {
      if (monthCode !== void 0) {
        year = impl.guessYearForMonthDay(monthCode, day);
      } else {
        throw new TypeError("either year or monthCode required with month");
      }
    }
    const isoFields = queryDateISOFields({ year, month, monthCode, day }, impl, options);
    return new PlainMonthDay(isoFields.isoMonth, isoFields.isoDay, this, impl.normalizeISOYearForMonthDay(isoFields.isoYear));
  }
  dateAdd(dateArg, durationArg, options) {
    const impl = getImpl2(this);
    const date = ensureObj(PlainDate, dateArg, options);
    const duration = ensureObj(Duration, durationArg);
    const overflowHandling = parseOverflowOption(options);
    const isoFields = addToDateFields(date, duration, impl, overflowHandling);
    return new PlainDate(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, this);
  }
  dateUntil(dateArg0, dateArg1, options) {
    const impl = getImpl2(this);
    const d0 = ensureObj(PlainDate, dateArg0);
    const d1 = ensureObj(PlainDate, dateArg1);
    const largestUnit = parseUnit(ensureOptionsObj(options).largestUnit, DAY, DAY, YEAR);
    ensureCalendarsEqual(getCommonCalendar(d0, d1), this);
    return diffDateFields(d0, d1, impl, largestUnit);
  }
  toString() {
    return this.id;
  }
};
function createDefaultCalendar() {
  return new Calendar(isoCalendarID);
}
function isoToEpochNanoSafe(calendarImpl, isoYear, isoMonth, isoDay) {
  const epochMilli = isoToEpochMilli(isoYear, isoMonth, isoDay);
  checkEpochMilliBuggy(epochMilli, calendarImpl.id);
  return calendarImpl.computeFields(epochMilli);
}

// src/argParse/calendar.ts
function isCalendarArgBag(arg) {
  return arg.calendar;
}
function parseCalendarArgFromBag(arg) {
  if (typeof arg === "object" && arg) {
    if (typeof arg.id === "string") {
      return arg;
    } else {
      throw new RangeError("Invalid calendar");
    }
  }
  return new Calendar(String(arg));
}
function extractCalendar(input) {
  if (input.calendar === void 0) {
    return createDefaultCalendar();
  }
  return ensureObj(Calendar, input.calendar);
}
function getCommonCalendar(obj0, obj1) {
  const { calendar } = obj0;
  ensureCalendarsEqual(calendar, obj1.calendar);
  return calendar;
}
function getStrangerCalendar(obj0, obj1) {
  const calendar0 = obj0.calendar;
  const calendar1 = obj1.calendar;
  if (calendar0.id === isoCalendarID) {
    return calendar1;
  }
  if (calendar1.id === isoCalendarID) {
    return calendar0;
  }
  if (calendar0.id !== calendar1.id) {
    throw new RangeError("Non-ISO calendars incompatible");
  }
  return calendar0;
}
function ensureCalendarsEqual(calendar0, calendar1) {
  if (calendar0.id !== calendar1.id) {
    throw new RangeError("Calendars must match");
  }
}

// src/public/plainDateTime.ts
var PlainDateTime = class extends AbstractISOObj {
  constructor(isoYear, isoMonth, isoDay, isoHour = 0, isoMinute = 0, isoSecond = 0, isoMillisecond = 0, isoMicrosecond = 0, isoNanosecond = 0, calendarArg = createDefaultCalendar()) {
    const constrained = constrainDateTimeISO({
      isoYear,
      isoMonth,
      isoDay,
      isoHour,
      isoMinute,
      isoSecond,
      isoMillisecond,
      isoMicrosecond,
      isoNanosecond
    }, OVERFLOW_REJECT);
    const calendar = ensureObj(Calendar, calendarArg);
    validateDateTime(constrained, calendar.id);
    super({
      ...constrained,
      calendar
    });
  }
  static from(arg, options) {
    const overflowHandling = parseOverflowOption(options);
    return createDateTime(arg instanceof PlainDateTime ? arg.getISOFields() : typeof arg === "object" ? dateTimeFieldsToISO(refineFields(arg, dateTimeFieldMap), options, overflowHandling, extractCalendar(arg)) : refineBaseObj(parseDateTime(String(arg))));
  }
  static compare(a, b) {
    return compareDateTimes(ensureObj(PlainDateTime, a), ensureObj(PlainDateTime, b));
  }
  with(fields, options) {
    const refinedFields = refineOverrideFields(fields, dateTimeFieldMap);
    const mergedFields = overrideDateTimeFields(refinedFields, this);
    return createDateTime(dateTimeFieldsToISO(mergedFields, options, parseOverflowOption(options), this.calendar));
  }
  withPlainDate(dateArg) {
    const date = ensureObj(PlainDate, dateArg);
    return createDateTime({
      ...this.getISOFields(),
      ...date.getISOFields(),
      calendar: getStrangerCalendar(this, date)
    });
  }
  withPlainTime(timeArg) {
    return createDateTime({
      ...this.getISOFields(),
      ...ensureLooseTime(timeArg).getISOFields()
    });
  }
  withCalendar(calendarArg) {
    return createDateTime({
      ...this.getISOFields(),
      calendar: ensureObj(Calendar, calendarArg)
    });
  }
  add(durationArg, options) {
    return addToDateTime(this, ensureObj(Duration, durationArg), options);
  }
  subtract(durationArg, options) {
    return addToDateTime(this, ensureObj(Duration, durationArg).negated(), options);
  }
  until(other, options) {
    return diffDateTimes(this, ensureObj(PlainDateTime, other), options);
  }
  since(other, options) {
    return diffDateTimes(this, ensureObj(PlainDateTime, other), options, true);
  }
  round(options) {
    return roundDateTimeWithOptions(this, options);
  }
  equals(other) {
    return compareDateTimes(this, ensureObj(PlainDateTime, other)) === 0;
  }
  toString(options) {
    const formatConfig = parseTimeToStringOptions(options);
    const calendarDisplay = parseCalendarDisplayOption(options);
    const isoFields = roundDateTime(this, formatConfig.roundingIncrement, formatConfig.roundingMode).getISOFields();
    return formatDateTimeISO(isoFields, formatConfig) + formatCalendarID(isoFields.calendar.id, calendarDisplay);
  }
  toZonedDateTime(timeZoneArg, options) {
    const timeZone = ensureObj(TimeZone, timeZoneArg);
    const instant = timeZone.getInstantFor(this, options);
    return new ZonedDateTime(instant.epochNanoseconds, timeZone, this.calendar);
  }
  toPlainYearMonth() {
    return createYearMonth(this.getISOFields());
  }
  toPlainMonthDay() {
    return this.calendar.monthDayFromFields(this);
  }
  toPlainDate() {
    return createDate(this.getISOFields());
  }
  toPlainTime() {
    return createTime(this.getISOFields());
  }
};
mixinISOFields(PlainDateTime, timeUnitNames);
mixinCalendarFields(PlainDateTime, dateCalendarFields);
mixinLocaleStringMethods(PlainDateTime, createPlainFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {}));

// src/dateUtils/dateTime.ts
function createDateTime(isoFields) {
  return new PlainDateTime(isoFields.isoYear, isoFields.isoMonth, isoFields.isoDay, isoFields.isoHour, isoFields.isoMinute, isoFields.isoSecond, isoFields.isoMillisecond, isoFields.isoMicrosecond, isoFields.isoNanosecond, isoFields.calendar);
}
function dateTimeFieldsToISO(fields, options, overflowHandling, calendar) {
  return {
    ...calendar.dateFromFields(fields, options).getISOFields(),
    ...timeFieldsToConstrainedISO(fields, overflowHandling)
  };
}
function overrideDateTimeFields(overrides, base) {
  return {
    ...overrideDateFields(overrides, base),
    ...overrideTimeFields(overrides, base)
  };
}
function constrainDateTimeISO(isoFields, overflow) {
  return {
    ...constrainDateISO(isoFields, overflow),
    ...constrainTimeISO(isoFields, overflow)
  };
}
function compareDateTimes(a, b) {
  return compareValues(isoFieldsToEpochNano(a.getISOFields()), isoFieldsToEpochNano(b.getISOFields())) || compareValues(a.calendar.id, b.calendar.id);
}
function addToDateTime(dateTime, duration, options) {
  const { calendar } = dateTime;
  const bigDuration = extractBigDuration(duration);
  const durationTimeFields = durationToTimeFields(duration);
  const date = calendar.dateAdd(createDate(dateTime.getISOFields()), bigDuration, options);
  return createDateTime({
    ...epochNanoToISOFields(isoFieldsToEpochNano(date.getISOFields()) + timeFieldsToNano(dateTime) + timeFieldsToNano(durationTimeFields)),
    calendar
  });
}
function diffDateTimes(dt0, dt1, options, flip) {
  const diffConfig = parseDiffOptions(options, DAY, NANOSECOND, NANOSECOND, YEAR);
  return roundBalancedDuration(diffAccurate(dt0, dt1, diffConfig.largestUnit), diffConfig, dt0, dt1, flip);
}
function roundDateTimeWithOptions(dateTime, options) {
  const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, DAY);
  return roundDateTime(dateTime, computeRoundingNanoIncrement(roundingConfig), roundingConfig.roundingMode);
}
function roundDateTime(dateTime, nanoIncrement, roundingFunc) {
  const dayTimeFields = roundTime(dateTime, nanoIncrement, roundingFunc);
  return createDateTime(combineISOWithDayTimeFields(dateTime.getISOFields(), dayTimeFields));
}

// src/dateUtils/instant.ts
function compareInstants(a, b) {
  return compareValues(a.epochNanoseconds, b.epochNanoseconds);
}
function addToInstant(instant, duration) {
  const largestUnit = computeLargestDurationUnit(duration);
  if (largestUnit >= DAY) {
    throw new RangeError("Duration cant have units larger than days");
  }
  return new Instant(instant.epochNanoseconds + timeFieldsToNano(durationToTimeFields(duration)));
}
function diffInstants(a, b, options) {
  const diffConfig = parseDiffOptions(options, SECOND, NANOSECOND, NANOSECOND, HOUR, true);
  return nanoToDuration(roundNano(b.epochNanoseconds - a.epochNanoseconds, diffConfig), diffConfig.largestUnit);
}
function roundInstant(instant, options) {
  const roundingConfig = parseRoundingOptions(options, void 0, NANOSECOND, HOUR, false, true);
  const [dayNano, timeNano] = splitEpochNano(instant.epochNanoseconds);
  return new Instant(dayNano + roundNano(timeNano, roundingConfig));
}

// src/public/instant.ts
var [getEpochNano, setEpochNano] = createWeakMap();
var Instant = class extends AbstractNoValueObj {
  constructor(epochNanoseconds) {
    super();
    epochNanoseconds = BigInt(epochNanoseconds);
    validateInstant(epochNanoseconds);
    setEpochNano(this, epochNanoseconds);
  }
  static from(arg) {
    if (arg instanceof Instant) {
      return new Instant(arg.epochNanoseconds);
    }
    const fields = parseZonedDateTime(String(arg));
    const offsetNano = fields.offset;
    if (offsetNano === void 0) {
      throw new RangeError("Must specify an offset");
    }
    return new Instant(isoFieldsToEpochNano(constrainDateTimeISO(fields, OVERFLOW_REJECT)) - BigInt(offsetNano));
  }
  static fromEpochSeconds(epochSeconds) {
    return new Instant(BigInt(epochSeconds) * nanoInSecondBI);
  }
  static fromEpochMilliseconds(epochMilliseconds) {
    return new Instant(BigInt(epochMilliseconds) * nanoInMilliBI);
  }
  static fromEpochMicroseconds(epochMicroseconds) {
    return new Instant(epochMicroseconds * nanoInMicroBI);
  }
  static fromEpochNanoseconds(epochNanoseconds) {
    return new Instant(epochNanoseconds);
  }
  static compare(a, b) {
    return compareInstants(ensureObj(Instant, a), ensureObj(Instant, b));
  }
  get epochNanoseconds() {
    return getEpochNano(this);
  }
  add(durationArg) {
    return addToInstant(this, ensureObj(Duration, durationArg));
  }
  subtract(durationArg) {
    return addToInstant(this, ensureObj(Duration, durationArg).negated());
  }
  until(other, options) {
    return diffInstants(this, ensureObj(Instant, other), options);
  }
  since(other, options) {
    return diffInstants(ensureObj(Instant, other), this, options);
  }
  round(options) {
    return roundInstant(this, options);
  }
  equals(other) {
    return compareInstants(this, ensureObj(Instant, other)) === 0;
  }
  toString(options) {
    const timeZoneArg = ensureOptionsObj(options).timeZone;
    const zonedDateTime = this.toZonedDateTimeISO(timeZoneArg ?? "UTC");
    return zonedDateTime.toString({
      ...options,
      offset: timeZoneArg === void 0 ? "never" : "auto",
      timeZoneName: "never"
    }) + (timeZoneArg === void 0 ? "Z" : "");
  }
  toZonedDateTimeISO(timeZoneArg) {
    return new ZonedDateTime(this.epochNanoseconds, timeZoneArg);
  }
  toZonedDateTime(options) {
    if (!isObjectLike(options)) {
      throw new TypeError("Must specify options");
    } else if (options.calendar === void 0) {
      throw new TypeError("Must specify a calendar");
    } else if (options.timeZone === void 0) {
      throw new TypeError("Must specify a timeZone");
    }
    return new ZonedDateTime(this.epochNanoseconds, options.timeZone, options.calendar);
  }
};
mixinEpochFields(Instant);
mixinLocaleStringMethods(Instant, createZonedFormatFactoryFactory({
  year: "numeric",
  month: "numeric",
  day: "numeric",
  weekday: void 0,
  hour: "numeric",
  minute: "2-digit",
  second: "2-digit"
}, {
  timeZoneName: void 0
}, {}));

// src/native/date.ts
function dateToTemporalInstant(date) {
  return Instant.fromEpochMilliseconds(date.valueOf());
}

// src/native/intlExtend.ts
var origLocalesSymbol = Symbol();
var origOptionsSymbol = Symbol();
var factoryMapSymbol = Symbol();
var ExtendedDateTimeFormat = class extends OrigDateTimeFormat {
  constructor(localesArg, options) {
    const normLocales = normalizeAndCopyLocalesArg(localesArg);
    const normOptions = flattenOptions(options || {});
    super(normLocales, normOptions);
    this[origLocalesSymbol] = normLocales;
    this[origOptionsSymbol] = normOptions;
    this[factoryMapSymbol] = /* @__PURE__ */ new Map();
  }
  format(dateArg) {
    const parts = createSingleArgs(this, dateArg);
    if (parts[0] === this) {
      return super.format(dateArg);
    }
    return parts[0].format(parts[1]);
  }
  formatToParts(dateArg) {
    return super.formatToParts.call(...createSingleArgs(this, dateArg));
  }
  formatRange(startArg, endArg) {
    return super.formatRange.call(...createRangeArgs(this, startArg, endArg));
  }
  formatRangeToParts(startArg, endArg) {
    return super.formatRangeToParts.call(...createRangeArgs(this, startArg, endArg));
  }
};
origLocalesSymbol, origOptionsSymbol, factoryMapSymbol;
function createSingleArgs(origDateTimeFormat, dateArg) {
  const buildFormatFactory = extractFormatFactoryFactory(dateArg);
  if (buildFormatFactory) {
    const formatFactory = queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory);
    return [
      formatFactory.buildFormat(dateArg),
      formatFactory.buildEpochMilli(dateArg)
    ];
  }
  return [origDateTimeFormat, dateArg];
}
function createRangeArgs(origDateTimeFormat, startArg, endArg) {
  const buildFormatFactory = extractFormatFactoryFactory(startArg);
  const buildFormatFactoryOther = extractFormatFactoryFactory(endArg);
  if (buildFormatFactory !== buildFormatFactoryOther) {
    throw new TypeError("Mismatch of types");
  }
  if (buildFormatFactory) {
    const formatFactory = queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory);
    return [
      formatFactory.buildFormat(startArg, endArg),
      formatFactory.buildEpochMilli(startArg),
      formatFactory.buildEpochMilli(endArg)
    ];
  }
  return [origDateTimeFormat, startArg, endArg];
}
function queryFormatFactoryForType(origDateTimeFormat, buildFormatFactory) {
  const formatFactoryMap = origDateTimeFormat[factoryMapSymbol];
  let formatFactory = formatFactoryMap.get(buildFormatFactory);
  if (!formatFactory) {
    formatFactory = buildCachedFormatFactory(buildFormatFactory(origDateTimeFormat[origLocalesSymbol], origDateTimeFormat[origOptionsSymbol]));
    formatFactoryMap.set(buildFormatFactory, formatFactory);
  }
  return formatFactory;
}

// src/public/now.ts
function getZonedDateTimeISO(timeZoneArg = getTimeZone()) {
  return getInstant().toZonedDateTimeISO(timeZoneArg);
}
function getZonedDateTime(calendarArg, timeZoneArg) {
  if (calendarArg === void 0) {
    throw new RangeError("Must specify calendar");
  }
  return getInstant().toZonedDateTime({
    calendar: calendarArg,
    timeZone: timeZoneArg ?? getTimeZone()
  });
}
function getPlainDateTimeISO(timeZoneArg = getTimeZone()) {
  return getZonedDateTimeISO(timeZoneArg).toPlainDateTime();
}
function getPlainDateTime(calendarArg, timeZoneArg) {
  return getZonedDateTime(calendarArg, timeZoneArg).toPlainDateTime();
}
function getPlainDateISO(timeZoneArg = getTimeZone()) {
  return getPlainDateTimeISO(timeZoneArg).toPlainDate();
}
function getPlainDate(calendarArg, timeZoneArg) {
  return getPlainDateTime(calendarArg, timeZoneArg).toPlainDate();
}
function getPlainTimeISO(timeZoneArg = getTimeZone()) {
  return getInstant().toZonedDateTimeISO(timeZoneArg).toPlainTime();
}
function getInstant() {
  return new Instant(BigInt(Date.now()) * nanoInMilliBI);
}
function getTimeZone() {
  return new TimeZone(new OrigDateTimeFormat().resolvedOptions().timeZone);
}
var Now = {
  zonedDateTimeISO: getZonedDateTimeISO,
  zonedDateTime: getZonedDateTime,
  plainDateTimeISO: getPlainDateTimeISO,
  plainDateTime: getPlainDateTime,
  plainDateISO: getPlainDateISO,
  plainDate: getPlainDate,
  plainTimeISO: getPlainTimeISO,
  instant: getInstant,
  timeZone: getTimeZone
};
module.exports = __toCommonJS(impl_exports);
